# This file was automatically generated by SWIG (http://www.swig.org).
# Version 1.3.40
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

"""

PyTrilinos.NOX is the python interface to the Trilinos nonlinear
solver package NOX:

    http://trilinos.sandia.gov/packages/nox

The purpose of NOX is to provide robust nonlinear solvers for the
problem of finding x such that F(x)=0.  In C++, NOX supports several
namespaces, some of which are sub-modules in python:

    * Abstract          - Base classes for abstract interface to NOX
    * Epetra            - Epetra implementation
    * Epetra.Interface  - Concrete interface for Epetra
    * Solver            - Solver manager class and supporting utilities
    * StatusTest        - Support for customizable stopping criteria

The top-level NOX module provides the following user-level class:

    * Utils  - Various utilities

For an example of usage of all of NOX, please consult the following
script in the example subdirectory of the PyTrilinos package:

    * exNOX_1Dfem.py

"""

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('___init__', [dirname(__file__)])
        except ImportError:
            import ___init__
            return ___init__
        if fp is not None:
            try:
                _mod = imp.load_module('___init__', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    ___init__ = swig_import_helper()
    del swig_import_helper
else:
    import ___init__
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    """Proxy of C++ swig::SwigPyIterator class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self):
        """value(self) -> PyObject"""
        return ___init__.SwigPyIterator_value(self)

    def incr(self, n = 1):
        """
        incr(self, size_t n = 1) -> SwigPyIterator
        incr(self) -> SwigPyIterator
        """
        return ___init__.SwigPyIterator_incr(self, n)

    def decr(self, n = 1):
        """
        decr(self, size_t n = 1) -> SwigPyIterator
        decr(self) -> SwigPyIterator
        """
        return ___init__.SwigPyIterator_decr(self, n)

    def distance(self, *args):
        """distance(self, SwigPyIterator x) -> ptrdiff_t"""
        return ___init__.SwigPyIterator_distance(self, *args)

    def equal(self, *args):
        """equal(self, SwigPyIterator x) -> bool"""
        return ___init__.SwigPyIterator_equal(self, *args)

    def copy(self):
        """copy(self) -> SwigPyIterator"""
        return ___init__.SwigPyIterator_copy(self)

    def next(self):
        """next(self) -> PyObject"""
        return ___init__.SwigPyIterator_next(self)

    def __next__(self):
        """__next__(self) -> PyObject"""
        return ___init__.SwigPyIterator___next__(self)

    def previous(self):
        """previous(self) -> PyObject"""
        return ___init__.SwigPyIterator_previous(self)

    def advance(self, *args):
        """advance(self, ptrdiff_t n) -> SwigPyIterator"""
        return ___init__.SwigPyIterator_advance(self, *args)

    def __eq__(self, *args):
        """__eq__(self, SwigPyIterator x) -> bool"""
        return ___init__.SwigPyIterator___eq__(self, *args)

    def __ne__(self, *args):
        """__ne__(self, SwigPyIterator x) -> bool"""
        return ___init__.SwigPyIterator___ne__(self, *args)

    def __iadd__(self, *args):
        """__iadd__(self, ptrdiff_t n) -> SwigPyIterator"""
        return ___init__.SwigPyIterator___iadd__(self, *args)

    def __isub__(self, *args):
        """__isub__(self, ptrdiff_t n) -> SwigPyIterator"""
        return ___init__.SwigPyIterator___isub__(self, *args)

    def __add__(self, *args):
        """__add__(self, ptrdiff_t n) -> SwigPyIterator"""
        return ___init__.SwigPyIterator___add__(self, *args)

    def __sub__(self, *args):
        """
        __sub__(self, ptrdiff_t n) -> SwigPyIterator
        __sub__(self, SwigPyIterator x) -> ptrdiff_t
        """
        return ___init__.SwigPyIterator___sub__(self, *args)

    def __iter__(self): return self
SwigPyIterator_swigregister = ___init__.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

import PyTrilinos.Teuchos
Have_Epetra = ___init__.Have_Epetra

def version(*args):
  """version() -> string"""
  return ___init__.version(*args)
__version__ = version().split()[2]

class Utils(_object):
    """
    Provides printing utilities.

    The following parameters are valid for this class and should be
    defined in the "Printing" sublist of the solver parameter list.

    "Output Information" - Can be a sublist or an integer. If it is an
    integer, this value is a sum of MsgType's to specify how much
    information to show. Defaults to NOX::Utils::Warning +
    NOX::Utils::OuterIteration + NOX::Utils::InnerIteration +
    NOX::Utils::Parameters = 0xf = 15. If this is a sublist, the following
    booleans are valid (set to true to enable print option): "Error"

    "Warning"

    "Outer Iteration"

    "Inner Iteration"

    "Parameters"

    "Details"

    "Outer Iteration StatusTest"

    "Linear Solver Details"

    "Test Details"

    "Stepper Iteration"

    "Stepper Details"

    "Stepper Parameters"

    "Debug"

    "Output Processor" - Specifies the designated print process.
    Defaults to 0.

    "MyPID" - Specifies this process's ID. Defaults to 0.

    "Output Precision" - Specifis the default number of decimal places
    to be used when printing floating point numbers. The default is 4.

    "Output Stream" - A Teuchos::RCP<std::ostream> object that will be
    used for standard output.

    "Error Stream" - A Teuchos::RCP<std::ostream> object that will be
    used for output of error information.

    The public variables should never be modified directly.

    C++ includes: NOX_Utils.H 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Utils, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Utils, name)
    __repr__ = _swig_repr
    Error = ___init__.Utils_Error
    Warning = ___init__.Utils_Warning
    OuterIteration = ___init__.Utils_OuterIteration
    InnerIteration = ___init__.Utils_InnerIteration
    Parameters = ___init__.Utils_Parameters
    Details = ___init__.Utils_Details
    OuterIterationStatusTest = ___init__.Utils_OuterIterationStatusTest
    LinearSolverDetails = ___init__.Utils_LinearSolverDetails
    TestDetails = ___init__.Utils_TestDetails
    StepperIteration = ___init__.Utils_StepperIteration
    StepperDetails = ___init__.Utils_StepperDetails
    StepperParameters = ___init__.Utils_StepperParameters
    Debug = ___init__.Utils_Debug
    def __init__(self, *args): 
        """
        __init__(self, int outputInformation = 0xf, int MyPID = 0, int outputProcess = 0, 
            int outputPrecision = 3, Teuchos::RCP<(std::ostream)> outputStream = Teuchos::null, 
            Teuchos::RCP<(std::ostream)> errorStream = Teuchos::null) -> Utils
        __init__(self, ParameterList p) -> Utils
        __init__(self, Utils u) -> Utils

        NOX::Utils::Utils(const
        NOX::Utils &u)

        Copy constructor. 
        """
        this = ___init__.new_Utils(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Utils
    __del__ = lambda self : None;
    def reset(self, *args):
        """
        reset(self, ParameterList p)

        void
        NOX::Utils::reset(Teuchos::ParameterList &p)

        Reset the printing parameters. 
        """
        return ___init__.Utils_reset(self, *args)

    def isPrintType(self, *args):
        """
        isPrintType(self, MsgType type) -> bool

        bool
        NOX::Utils::isPrintType(NOX::Utils::MsgType type) const

        Returns true if this is a valid print type. 
        """
        return ___init__.Utils_isPrintType(self, *args)

    def out(self, *args):
        """
        out(self) -> std::ostream
        out(self, MsgType type) -> std::ostream

        std::ostream &
        NOX::Utils::out(NOX::Utils::MsgType type) const

        Returns the ostream for printing if this process is the print process
        and the print type is valid. Returns a Teuchos::oblackholestream
        otherwise. 
        """
        return ___init__.Utils_out(self, *args)

    def pout(self, *args):
        """
        pout(self) -> std::ostream
        pout(self, MsgType type) -> std::ostream

        std::ostream &
        NOX::Utils::pout(NOX::Utils::MsgType type) const

        Returns the ostream for printing if the print type matches. Only use
        this call if you want all processes to print to the ostream for the
        print type. 
        """
        return ___init__.Utils_pout(self, *args)

    def err(self, *args):
        """
        err(self) -> std::ostream

        std::ostream &
        NOX::Utils::err() const

        Returns the error stream for printing if this is the print process. 
        """
        return ___init__.Utils_err(self, *args)

    def perr(self, *args):
        """
        perr(self) -> std::ostream

        std::ostream &
        NOX::Utils::perr() const

        Returns the error stream for printing to all processors. Only use this
        call if you want all processes to print to the error stream. 
        """
        return ___init__.Utils_perr(self, *args)

    def _print(self, *args):
        """
        _print(self, ostream os)

        void
        NOX::Utils::print(ostream &os) const

        Print this object. 
        """
        return ___init__.Utils__print(self, *args)

Utils_swigregister = ___init__.Utils_swigregister
Utils_swigregister(Utils)

# Abstract, Solver, and StatusTest namespaces
__all__ = ['Abstract', 'Solver', 'StatusTest']
import Abstract
import Solver
import StatusTest

# Epetra namespace
__all__.append('Epetra')

def defaultNonlinearParameters(comm=None, verbosity=0, outputPrec=3,
                               maxIterations=800, tolerance=1.0e-4):
    """
    defaultNonlinearParameters(comm=None, verbosity=0, outputPrec=3,
                               maxIterations=800, tolerance=1.0e-4) -> dict

    Return a dictionary that can serve as a default list of parameters for a NOX
    solver.  Entries can be altered before passing to a NOX solver constructor.

    comm          - Epetra communicator object.  If not provided, the function
                    uses an Epetra.SerialComm communicator.

    verbosity     - A simple indication of verbosity level.  0: errors and test
                    details.  1: debugging, warnings, details, parameters and
                    linear solver details.  2: inner iteration, outer iteration
                    status test and outer iteration.  Default 0.

    outputPrec    - Number of significant digits to output.  Default 3.

    maxIterations - Maximum allowable linear (inner) iterations.  Default 800.

    tolerance     - Linear solver tolerance level.  Default 1.0e-4.
    """
    # Communicator
    if comm is None:
        comm = Epetra.SerialComm()
    myPID = comm.MyPID()

    # Create the printing parameter list
    outputInfo = Utils.Error + Utils.TestDetails
    if verbosity: outputInfo += Utils.Debug      + \
                                Utils.Warning    + \
                                Utils.Details    + \
                                Utils.Parameters + \
                                Utils.LinearSolverDetails
    if verbosity > 1: outputInfo += Utils.InnerIteration           + \
                                    Utils.OuterIterationStatusTest + \
                                    Utils.OuterIteration
    printParams = {"MyPID"              : myPID,
                   "Output Precision"   : outputPrec,
                   "Output Processor"   : 0,
                   "Output Information" : outputInfo}

    # Create the linear solver parameter list
    lsParams = {"Aztec Solver"    : "GMRES",
                "Max Iterations"  : maxIterations,
                "Tolerance"       : tolerance,
                "Preconditioner"  : "Ifpack",
                "Max Age Of Prec" : 5       }

    # Create the nonlinear solver parameter list
    nlParams = {"Nonlinear Solver" : "Line Search Based",
                "Printing"         : printParams,
                "Line Search"      : {"Method" : "Full Step"},
                "Direction"        : {"Method" : "Newton"},
                "Newton"           : {"Forcing Term Method" : "Constant"},
                "Linear Solver"    : lsParams,
                "Solver Options"   : {"Status Test Check Type" : "Complete"}
                }
    
    return nlParams

def defaultGroup(nonlinearParameters, initGuess, reqInterface, jacInterface=None,
                 jacobian=None, precInterface=None, preconditioner=None):
    """
    defaultGroup(nonlinearParameters, initGuess, reqInterface, jacInterface=None,
                 jacobian=None, precInterface=None, preconditioner=None) -> Group

    Return a NOX.Epetra.Group based upon the given input arguments:

    nonlinearParameters - a dict with nonlinear parameters.  Can be obtained
                          from defaultNonlinearParameters()
    initGuess           - an initial guess Epetra.Vector.
    reqInterface        - an Interface.Required object
    jacInterface        - an Interface.Jacobian object
    jacobian            - if jacInterface is given, this should be the
                          Epetra.Operator that is the Jacobian matrix
    precInterface       - an Interface.Preconditioner object
    preconditioner      - if precInterface is given, this should be the
                          Epetra.Operator that is the Preconditioner
    """
    # Extract parameter lists
    printParams = nonlinearParameters["Printing"     ]
    lsParams    = nonlinearParameters["Linear Solver"]

    # Construct a NOX.Epetra.Vector from the Epetra.Vector
    clone = Epetra.Vector(initGuess, Epetra.Vector.CreateView)

    # Construct the linear system
    if jacInterface:
        if precInterface:
            linSys = Epetra.LinearSystemAztecOO(printParams, lsParams,
                                                jacInterface, jacobian,
                                                precInterface, preconditioner,
                                                clone)
        else:
            linSys = Epetra.LinearSystemAztecOO(printParams, lsParams,
                                                reqInterface,
                                                jacInterface, jacobian,
                                                clone)
    else:
        if precInterface:
            linSys = Epetra.LinearSystemAztecOO(printParams, lsParams,
                                                reqInterface,
                                                precInterface, preconditioner,
                                                clone)
        else:
            linSys = Epetra.LinearSystemAztecOO(printParams, lsParams,
                                                reqInterface,
                                                clone)

    # Construct and return the default Group
    group = Epetra.Group(printParams, reqInterface, clone, linSys)
    group.linSys = linSys   ### By adding linSys as an attribute to the Group
                            ### variable, we ensure that linSys does not get
                            ### destroyed.  This is a workaround for a
                            ### Teuchos::RCP wrapper bug.
    return group

def defaultStatusTest(absTol=None, relTol=None, relGroup=None, updateTol=None,
                      wAbsTol=None, wRelTol=None, maxIters=None,
                      finiteValue=False):
    """
    defaultStatusTest(absTol=None, relTol=None, relGroup=None, updateTol=None,
                      wAbsTol=None, wRelTol=None, maxIters=None,
                      finiteValue=False) -> StatusTest

    Return a StatusTest object based upon the input arguments:

    absTol      - if specified, include an absolute residual status test, using
                  this value as the tolerance
    relTol      - if specified, along with relGroup, include a relative residual
                  status test, using this value as the tolerance
    relGroup    - if specified, along with relTol, include a relative residual
                  status test, using this Group to determine the scaling
    updateTol   - if specified, include an update status test, using this value
                  as the tolerance
    wAbsTol     - if specified, along with wRelTol, include a weighted RMS
                  status test, using this value as the absolute tolerance
    wRelTol     - if specified, along with wAbsTol, include a weighted RMS
                  status test, using this value as the relative tolerance
    maxIters    - if specified, include a maximum iterations status test, using
                  this value as the maximum allowable iterations
    finiteValue - if True, include a finite value status test.  Default False.
    """
    # Build the convergence portion of the status test
    converged = StatusTest.Combo(StatusTest.Combo.AND)
    converged.tests = [ ]   ### By adding this list of tests as an attribute to
                            ### the StatusTest variables, we ensure that linSys
                            ### does not get destroyed.  This is a workaround
                            ### for a Teuchos::RCP wrapper bug.

    if absTol:
        absTest = StatusTest.NormF(absTol)
        converged.addStatusTest(absTest)
        converged.tests.append(absTest)
    if relGroup and relTol:
        relTest = StatusTest.NormF(relGroup,relTol)
        converged.addStatusTest(relTest)
        converged.tests.append(relTest)
    if wAbsTol and wRelTol:
        wrmsTest = StatusTest.NormWRMS(wRelTol,wAbsTol)
        converged.addStatusTest(wrmsTest)
        converged.tests.append(wrmsTest)
    if updateTol:
        updateTest = StatusTest.NormUpdate(updateTol)
        converged.addStatusTest(updateTest)
        converged.tests.append(updateTest)

    # Return if done
    if not (maxIters or finiteValue):
        return converged

    # Add the divergence portion of the default status test
    combo = StatusTest.Combo(StatusTest.Combo.OR)
    combo.tests = [ ]
    if finiteValue:
        fvTest = StatusTest.FiniteValue()
        combo.addStatusTest(fvTest)
        combo.tests.append(fvTest)
    combo.addStatusTest(converged)
    combo.tests.append(converged)
    if maxIters:
        maxIterTest = StatusTest.MaxIters(maxIters)
        combo.addStatusTest(maxIterTest)
        combo.tests.append(maxIterTest)
    return combo

def defaultSolver(initGuess, reqInterface, jacInterface=None, jacobian=None,
                  precInterface=None, preconditioner=None, nlParams=None):
    """
    defaultSolver(initGuess, reqInterface, jacInterface=None, jacobian=None,
                  precInterface=None, preconditioner=None, nlParams=None) -> Solver

    Return a default NOX Solver based on the given arguments:

    initGuess      - an Epetra.Vector initial guess
    reqInterface   - a NOX.Epetra.Interface.Required object that defines the
                     interface to the nonlinear problem
    jacInterface   - a NOX.Epetra.Interface.Jacobian object that defines the
                     Jacobian of the nonlinear problem. Default None.
    jacobian       - an Epetra.Operator that defines the Jacobian matrix.
                     Default None.
    precInterface  - a NOX.Epetra.Interface.Preconditioner object that defines
                     the preconditioner to the nonlinear problem. Default None.
    preconditioner - an Epetra.Operator that defines the preconditioner.
                     Default None.
    nlParams       - dict that contains a list of nonlinear parameters.  Default
                     None, in which case defaultNonlinearParameters() is used.
    """
    # Get the communicator
    comm = initGuess.Comm()

    # Get the nonlinear parameters
    if nlParams is None:
        nlParams = defaultNonlinearParameters(comm,2)

    # Build the default Group
    group = defaultGroup(nlParams, initGuess, reqInterface, jacInterface,
                         jacobian, precInterface, preconditioner)

    # Get the default StatusTest
    statusTest = defaultStatusTest(absTol      = 1.0e-8,
                                   relTol      = 1.0e-2,
                                   relGroup    = group,
                                   updateTol   = 1.0e-5,
                                   wAbsTol     = 1.0e-8,
                                   wRelTol     = 1.0e-2,
                                   maxIters    = 20,
                                   finiteValue = True)

    # Return the default Solver
    solver = Solver.buildSolver(group, statusTest, nlParams)
    solver.group      = group        ### By adding group, statusTest and
    solver.statusTest = statusTest   ### nlParams as attributes to the Solver
    solver.nlParams   = nlParams     ### variable, we ensure that they do not
                                     ### get destroyed.  This is a workaround for
                                     ### a Teuchos::RCP wrapper bug.
    return solver



