# This file was automatically generated by SWIG (http://www.swig.org).
# Version 1.3.40
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

"""

PyTrilinos.Teuchos is the python interface to the Trilinos tools and
utilities package Teuchos:

    http://trilinos.sandia.gov/packages/teuchos

The purpose of Teuchos is to provide a number of utilities often
needed by numerical applications, but that are not necessarily
numerical by nature.  The python version of the Teuchos package
supports the following classes:

    * SerialComm              - Serial communicator
    * MpiComm                 - MPI communicator
    * DefaultComm             - Default communicator facility
    * ParameterList           - List of arbitrarily-typed values,
                                keyed by strings
    * XMLObject               - Object-oriented interface to XML
                                objects
    * XMLParameterListReader  - ParameterList input from XML
    * XMLParameterListWriter  - ParameterList output to XML
    * XMLInputSource          - Base class for converting a stream
                                to XML
    * FileInputSource         - Class for converting file contents
                                to XML
    * StringInputSource       - Class for converting string contents
                                to XML
    * ScalarTraits            - Function factory for ScalarTraits<...>
                                classes
    * Time                    - Wall-clock timer class

The ParameterList class matches string keys to arbitrarily-typed
values.  In python, the Teuchos.ParameterList is tightly integrated
with python dictionaries -- PyTrilinos methods that expect a
ParameterList will accept a python dictionary.

"""

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Teuchos', [dirname(__file__)])
        except ImportError:
            import _Teuchos
            return _Teuchos
        if fp is not None:
            try:
                _mod = imp.load_module('_Teuchos', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Teuchos = swig_import_helper()
    del swig_import_helper
else:
    import _Teuchos
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    """Proxy of C++ swig::SwigPyIterator class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Teuchos.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self, *args):
        """value(self) -> PyObject"""
        return _Teuchos.SwigPyIterator_value(self, *args)

    def incr(self, *args):
        """incr(self, size_t n = 1) -> SwigPyIterator"""
        return _Teuchos.SwigPyIterator_incr(self, *args)

    def decr(self, *args):
        """decr(self, size_t n = 1) -> SwigPyIterator"""
        return _Teuchos.SwigPyIterator_decr(self, *args)

    def distance(self, *args):
        """distance(self, SwigPyIterator x) -> ptrdiff_t"""
        return _Teuchos.SwigPyIterator_distance(self, *args)

    def equal(self, *args):
        """equal(self, SwigPyIterator x) -> bool"""
        return _Teuchos.SwigPyIterator_equal(self, *args)

    def copy(self, *args):
        """copy(self) -> SwigPyIterator"""
        return _Teuchos.SwigPyIterator_copy(self, *args)

    def next(self, *args):
        """next(self) -> PyObject"""
        return _Teuchos.SwigPyIterator_next(self, *args)

    def __next__(self, *args):
        """__next__(self) -> PyObject"""
        return _Teuchos.SwigPyIterator___next__(self, *args)

    def previous(self, *args):
        """previous(self) -> PyObject"""
        return _Teuchos.SwigPyIterator_previous(self, *args)

    def advance(self, *args):
        """advance(self, ptrdiff_t n) -> SwigPyIterator"""
        return _Teuchos.SwigPyIterator_advance(self, *args)

    def __eq__(self, *args):
        """__eq__(self, SwigPyIterator x) -> bool"""
        return _Teuchos.SwigPyIterator___eq__(self, *args)

    def __ne__(self, *args):
        """__ne__(self, SwigPyIterator x) -> bool"""
        return _Teuchos.SwigPyIterator___ne__(self, *args)

    def __iadd__(self, *args):
        """__iadd__(self, ptrdiff_t n) -> SwigPyIterator"""
        return _Teuchos.SwigPyIterator___iadd__(self, *args)

    def __isub__(self, *args):
        """__isub__(self, ptrdiff_t n) -> SwigPyIterator"""
        return _Teuchos.SwigPyIterator___isub__(self, *args)

    def __add__(self, *args):
        """__add__(self, ptrdiff_t n) -> SwigPyIterator"""
        return _Teuchos.SwigPyIterator___add__(self, *args)

    def __sub__(self, *args):
        """
        __sub__(self, ptrdiff_t n) -> SwigPyIterator
        __sub__(self, SwigPyIterator x) -> ptrdiff_t
        """
        return _Teuchos.SwigPyIterator___sub__(self, *args)

    def __iter__(self): return self
SwigPyIterator_swigregister = _Teuchos.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)


def throwScalarTraitsNanInfError(*args):
  """throwScalarTraitsNanInfError(string errMsg)"""
  return _Teuchos.throwScalarTraitsNanInfError(*args)
class ScalarTraitsByte(_object):
    """ """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsByte, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsByte, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsByte_isComplex
    isOrdinal = _Teuchos.ScalarTraitsByte_isOrdinal
    isComparable = _Teuchos.ScalarTraitsByte_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsByte_hasMachineParameters
    def magnitude(*args):
        """magnitude(char a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsByte_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> char"""
        return _Teuchos.ScalarTraitsByte_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> char"""
        return _Teuchos.ScalarTraitsByte_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(char x) -> char"""
        return _Teuchos.ScalarTraitsByte_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(char x) -> char"""
        return _Teuchos.ScalarTraitsByte_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(char arg0) -> char"""
        return _Teuchos.ScalarTraitsByte_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def isnaninf(*args):
        """isnaninf(char arg0) -> bool"""
        return _Teuchos.ScalarTraitsByte_isnaninf(*args)

    if _newclass:isnaninf = staticmethod(isnaninf)
    __swig_getmethods__["isnaninf"] = lambda x: isnaninf
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsByte_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> char"""
        return _Teuchos.ScalarTraitsByte_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsByte_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(char x) -> char"""
        return _Teuchos.ScalarTraitsByte_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(char x, char y) -> char"""
        return _Teuchos.ScalarTraitsByte_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsByte

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsByte(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsByte
    __del__ = lambda self : None;
ScalarTraitsByte_swigregister = _Teuchos.ScalarTraitsByte_swigregister
ScalarTraitsByte_swigregister(ScalarTraitsByte)
cvar = _Teuchos.cvar
flt_nan = cvar.flt_nan
dbl_nan = cvar.dbl_nan

def ScalarTraitsByte_magnitude(*args):
  """ScalarTraitsByte_magnitude(char a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsByte_magnitude(*args)

def ScalarTraitsByte_zero(*args):
  """ScalarTraitsByte_zero() -> char"""
  return _Teuchos.ScalarTraitsByte_zero(*args)

def ScalarTraitsByte_one(*args):
  """ScalarTraitsByte_one() -> char"""
  return _Teuchos.ScalarTraitsByte_one(*args)

def ScalarTraitsByte_conjugate(*args):
  """ScalarTraitsByte_conjugate(char x) -> char"""
  return _Teuchos.ScalarTraitsByte_conjugate(*args)

def ScalarTraitsByte_real(*args):
  """ScalarTraitsByte_real(char x) -> char"""
  return _Teuchos.ScalarTraitsByte_real(*args)

def ScalarTraitsByte_imag(*args):
  """ScalarTraitsByte_imag(char arg0) -> char"""
  return _Teuchos.ScalarTraitsByte_imag(*args)

def ScalarTraitsByte_isnaninf(*args):
  """ScalarTraitsByte_isnaninf(char arg0) -> bool"""
  return _Teuchos.ScalarTraitsByte_isnaninf(*args)

def ScalarTraitsByte_seedrandom(*args):
  """ScalarTraitsByte_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsByte_seedrandom(*args)

def ScalarTraitsByte_random(*args):
  """ScalarTraitsByte_random() -> char"""
  return _Teuchos.ScalarTraitsByte_random(*args)

def ScalarTraitsByte_name(*args):
  """ScalarTraitsByte_name() -> string"""
  return _Teuchos.ScalarTraitsByte_name(*args)

def ScalarTraitsByte_squareroot(*args):
  """ScalarTraitsByte_squareroot(char x) -> char"""
  return _Teuchos.ScalarTraitsByte_squareroot(*args)

def ScalarTraitsByte_pow(*args):
  """ScalarTraitsByte_pow(char x, char y) -> char"""
  return _Teuchos.ScalarTraitsByte_pow(*args)

class ScalarTraitsUbyte(_object):
    """Proxy of C++ Teuchos::ScalarTraits<(unsigned char)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsUbyte, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsUbyte, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsUbyte_isComplex
    isComparable = _Teuchos.ScalarTraitsUbyte_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsUbyte_hasMachineParameters
    def magnitude(*args):
        """magnitude(unsigned char a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsUbyte_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> unsigned char"""
        return _Teuchos.ScalarTraitsUbyte_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> unsigned char"""
        return _Teuchos.ScalarTraitsUbyte_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(unsigned char x) -> unsigned char"""
        return _Teuchos.ScalarTraitsUbyte_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(unsigned char x) -> unsigned char"""
        return _Teuchos.ScalarTraitsUbyte_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(unsigned char x) -> unsigned char"""
        return _Teuchos.ScalarTraitsUbyte_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsUbyte_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> unsigned char"""
        return _Teuchos.ScalarTraitsUbyte_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsUbyte_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(unsigned char x) -> unsigned char"""
        return _Teuchos.ScalarTraitsUbyte_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(unsigned char x, unsigned char y) -> unsigned char"""
        return _Teuchos.ScalarTraitsUbyte_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsUbyte

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsUbyte(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsUbyte
    __del__ = lambda self : None;
ScalarTraitsUbyte_swigregister = _Teuchos.ScalarTraitsUbyte_swigregister
ScalarTraitsUbyte_swigregister(ScalarTraitsUbyte)

def ScalarTraitsUbyte_magnitude(*args):
  """ScalarTraitsUbyte_magnitude(unsigned char a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsUbyte_magnitude(*args)

def ScalarTraitsUbyte_zero(*args):
  """ScalarTraitsUbyte_zero() -> unsigned char"""
  return _Teuchos.ScalarTraitsUbyte_zero(*args)

def ScalarTraitsUbyte_one(*args):
  """ScalarTraitsUbyte_one() -> unsigned char"""
  return _Teuchos.ScalarTraitsUbyte_one(*args)

def ScalarTraitsUbyte_conjugate(*args):
  """ScalarTraitsUbyte_conjugate(unsigned char x) -> unsigned char"""
  return _Teuchos.ScalarTraitsUbyte_conjugate(*args)

def ScalarTraitsUbyte_real(*args):
  """ScalarTraitsUbyte_real(unsigned char x) -> unsigned char"""
  return _Teuchos.ScalarTraitsUbyte_real(*args)

def ScalarTraitsUbyte_imag(*args):
  """ScalarTraitsUbyte_imag(unsigned char x) -> unsigned char"""
  return _Teuchos.ScalarTraitsUbyte_imag(*args)

def ScalarTraitsUbyte_seedrandom(*args):
  """ScalarTraitsUbyte_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsUbyte_seedrandom(*args)

def ScalarTraitsUbyte_random(*args):
  """ScalarTraitsUbyte_random() -> unsigned char"""
  return _Teuchos.ScalarTraitsUbyte_random(*args)

def ScalarTraitsUbyte_name(*args):
  """ScalarTraitsUbyte_name() -> string"""
  return _Teuchos.ScalarTraitsUbyte_name(*args)

def ScalarTraitsUbyte_squareroot(*args):
  """ScalarTraitsUbyte_squareroot(unsigned char x) -> unsigned char"""
  return _Teuchos.ScalarTraitsUbyte_squareroot(*args)

def ScalarTraitsUbyte_pow(*args):
  """ScalarTraitsUbyte_pow(unsigned char x, unsigned char y) -> unsigned char"""
  return _Teuchos.ScalarTraitsUbyte_pow(*args)

class ScalarTraitsShort(_object):
    """ """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsShort, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsShort, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsShort_isComplex
    isOrdinal = _Teuchos.ScalarTraitsShort_isOrdinal
    isComparable = _Teuchos.ScalarTraitsShort_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsShort_hasMachineParameters
    def magnitude(*args):
        """magnitude(short a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsShort_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> short"""
        return _Teuchos.ScalarTraitsShort_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> short"""
        return _Teuchos.ScalarTraitsShort_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(short x) -> short"""
        return _Teuchos.ScalarTraitsShort_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(short x) -> short"""
        return _Teuchos.ScalarTraitsShort_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(short arg0) -> short"""
        return _Teuchos.ScalarTraitsShort_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsShort_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> short"""
        return _Teuchos.ScalarTraitsShort_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsShort_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(short x) -> short"""
        return _Teuchos.ScalarTraitsShort_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(short x, short y) -> short"""
        return _Teuchos.ScalarTraitsShort_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsShort

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsShort(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsShort
    __del__ = lambda self : None;
ScalarTraitsShort_swigregister = _Teuchos.ScalarTraitsShort_swigregister
ScalarTraitsShort_swigregister(ScalarTraitsShort)

def ScalarTraitsShort_magnitude(*args):
  """ScalarTraitsShort_magnitude(short a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsShort_magnitude(*args)

def ScalarTraitsShort_zero(*args):
  """ScalarTraitsShort_zero() -> short"""
  return _Teuchos.ScalarTraitsShort_zero(*args)

def ScalarTraitsShort_one(*args):
  """ScalarTraitsShort_one() -> short"""
  return _Teuchos.ScalarTraitsShort_one(*args)

def ScalarTraitsShort_conjugate(*args):
  """ScalarTraitsShort_conjugate(short x) -> short"""
  return _Teuchos.ScalarTraitsShort_conjugate(*args)

def ScalarTraitsShort_real(*args):
  """ScalarTraitsShort_real(short x) -> short"""
  return _Teuchos.ScalarTraitsShort_real(*args)

def ScalarTraitsShort_imag(*args):
  """ScalarTraitsShort_imag(short arg0) -> short"""
  return _Teuchos.ScalarTraitsShort_imag(*args)

def ScalarTraitsShort_seedrandom(*args):
  """ScalarTraitsShort_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsShort_seedrandom(*args)

def ScalarTraitsShort_random(*args):
  """ScalarTraitsShort_random() -> short"""
  return _Teuchos.ScalarTraitsShort_random(*args)

def ScalarTraitsShort_name(*args):
  """ScalarTraitsShort_name() -> string"""
  return _Teuchos.ScalarTraitsShort_name(*args)

def ScalarTraitsShort_squareroot(*args):
  """ScalarTraitsShort_squareroot(short x) -> short"""
  return _Teuchos.ScalarTraitsShort_squareroot(*args)

def ScalarTraitsShort_pow(*args):
  """ScalarTraitsShort_pow(short x, short y) -> short"""
  return _Teuchos.ScalarTraitsShort_pow(*args)

class ScalarTraitsUshort(_object):
    """Proxy of C++ Teuchos::ScalarTraits<(unsigned short)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsUshort, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsUshort, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsUshort_isComplex
    isComparable = _Teuchos.ScalarTraitsUshort_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsUshort_hasMachineParameters
    def magnitude(*args):
        """magnitude(unsigned short a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsUshort_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> unsigned short"""
        return _Teuchos.ScalarTraitsUshort_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> unsigned short"""
        return _Teuchos.ScalarTraitsUshort_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(unsigned short x) -> unsigned short"""
        return _Teuchos.ScalarTraitsUshort_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(unsigned short x) -> unsigned short"""
        return _Teuchos.ScalarTraitsUshort_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(unsigned short x) -> unsigned short"""
        return _Teuchos.ScalarTraitsUshort_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsUshort_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> unsigned short"""
        return _Teuchos.ScalarTraitsUshort_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsUshort_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(unsigned short x) -> unsigned short"""
        return _Teuchos.ScalarTraitsUshort_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(unsigned short x, unsigned short y) -> unsigned short"""
        return _Teuchos.ScalarTraitsUshort_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsUshort

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsUshort(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsUshort
    __del__ = lambda self : None;
ScalarTraitsUshort_swigregister = _Teuchos.ScalarTraitsUshort_swigregister
ScalarTraitsUshort_swigregister(ScalarTraitsUshort)

def ScalarTraitsUshort_magnitude(*args):
  """ScalarTraitsUshort_magnitude(unsigned short a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsUshort_magnitude(*args)

def ScalarTraitsUshort_zero(*args):
  """ScalarTraitsUshort_zero() -> unsigned short"""
  return _Teuchos.ScalarTraitsUshort_zero(*args)

def ScalarTraitsUshort_one(*args):
  """ScalarTraitsUshort_one() -> unsigned short"""
  return _Teuchos.ScalarTraitsUshort_one(*args)

def ScalarTraitsUshort_conjugate(*args):
  """ScalarTraitsUshort_conjugate(unsigned short x) -> unsigned short"""
  return _Teuchos.ScalarTraitsUshort_conjugate(*args)

def ScalarTraitsUshort_real(*args):
  """ScalarTraitsUshort_real(unsigned short x) -> unsigned short"""
  return _Teuchos.ScalarTraitsUshort_real(*args)

def ScalarTraitsUshort_imag(*args):
  """ScalarTraitsUshort_imag(unsigned short x) -> unsigned short"""
  return _Teuchos.ScalarTraitsUshort_imag(*args)

def ScalarTraitsUshort_seedrandom(*args):
  """ScalarTraitsUshort_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsUshort_seedrandom(*args)

def ScalarTraitsUshort_random(*args):
  """ScalarTraitsUshort_random() -> unsigned short"""
  return _Teuchos.ScalarTraitsUshort_random(*args)

def ScalarTraitsUshort_name(*args):
  """ScalarTraitsUshort_name() -> string"""
  return _Teuchos.ScalarTraitsUshort_name(*args)

def ScalarTraitsUshort_squareroot(*args):
  """ScalarTraitsUshort_squareroot(unsigned short x) -> unsigned short"""
  return _Teuchos.ScalarTraitsUshort_squareroot(*args)

def ScalarTraitsUshort_pow(*args):
  """ScalarTraitsUshort_pow(unsigned short x, unsigned short y) -> unsigned short"""
  return _Teuchos.ScalarTraitsUshort_pow(*args)

class ScalarTraitsInt(_object):
    """ """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsInt, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsInt, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsInt_isComplex
    isOrdinal = _Teuchos.ScalarTraitsInt_isOrdinal
    isComparable = _Teuchos.ScalarTraitsInt_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsInt_hasMachineParameters
    def magnitude(*args):
        """magnitude(int a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsInt_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> int"""
        return _Teuchos.ScalarTraitsInt_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> int"""
        return _Teuchos.ScalarTraitsInt_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(int x) -> int"""
        return _Teuchos.ScalarTraitsInt_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(int x) -> int"""
        return _Teuchos.ScalarTraitsInt_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(int arg0) -> int"""
        return _Teuchos.ScalarTraitsInt_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def isnaninf(*args):
        """isnaninf(int arg0) -> bool"""
        return _Teuchos.ScalarTraitsInt_isnaninf(*args)

    if _newclass:isnaninf = staticmethod(isnaninf)
    __swig_getmethods__["isnaninf"] = lambda x: isnaninf
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsInt_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> int"""
        return _Teuchos.ScalarTraitsInt_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsInt_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(int x) -> int"""
        return _Teuchos.ScalarTraitsInt_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(int x, int y) -> int"""
        return _Teuchos.ScalarTraitsInt_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsInt

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsInt(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsInt
    __del__ = lambda self : None;
ScalarTraitsInt_swigregister = _Teuchos.ScalarTraitsInt_swigregister
ScalarTraitsInt_swigregister(ScalarTraitsInt)

def ScalarTraitsInt_magnitude(*args):
  """ScalarTraitsInt_magnitude(int a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsInt_magnitude(*args)

def ScalarTraitsInt_zero(*args):
  """ScalarTraitsInt_zero() -> int"""
  return _Teuchos.ScalarTraitsInt_zero(*args)

def ScalarTraitsInt_one(*args):
  """ScalarTraitsInt_one() -> int"""
  return _Teuchos.ScalarTraitsInt_one(*args)

def ScalarTraitsInt_conjugate(*args):
  """ScalarTraitsInt_conjugate(int x) -> int"""
  return _Teuchos.ScalarTraitsInt_conjugate(*args)

def ScalarTraitsInt_real(*args):
  """ScalarTraitsInt_real(int x) -> int"""
  return _Teuchos.ScalarTraitsInt_real(*args)

def ScalarTraitsInt_imag(*args):
  """ScalarTraitsInt_imag(int arg0) -> int"""
  return _Teuchos.ScalarTraitsInt_imag(*args)

def ScalarTraitsInt_isnaninf(*args):
  """ScalarTraitsInt_isnaninf(int arg0) -> bool"""
  return _Teuchos.ScalarTraitsInt_isnaninf(*args)

def ScalarTraitsInt_seedrandom(*args):
  """ScalarTraitsInt_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsInt_seedrandom(*args)

def ScalarTraitsInt_random(*args):
  """ScalarTraitsInt_random() -> int"""
  return _Teuchos.ScalarTraitsInt_random(*args)

def ScalarTraitsInt_name(*args):
  """ScalarTraitsInt_name() -> string"""
  return _Teuchos.ScalarTraitsInt_name(*args)

def ScalarTraitsInt_squareroot(*args):
  """ScalarTraitsInt_squareroot(int x) -> int"""
  return _Teuchos.ScalarTraitsInt_squareroot(*args)

def ScalarTraitsInt_pow(*args):
  """ScalarTraitsInt_pow(int x, int y) -> int"""
  return _Teuchos.ScalarTraitsInt_pow(*args)

class ScalarTraitsUint(_object):
    """ """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsUint, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsUint, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsUint_isComplex
    isOrdinal = _Teuchos.ScalarTraitsUint_isOrdinal
    isComparable = _Teuchos.ScalarTraitsUint_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsUint_hasMachineParameters
    def magnitude(*args):
        """magnitude(unsigned int a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsUint_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> unsigned int"""
        return _Teuchos.ScalarTraitsUint_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> unsigned int"""
        return _Teuchos.ScalarTraitsUint_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(unsigned int x) -> unsigned int"""
        return _Teuchos.ScalarTraitsUint_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(unsigned int x) -> unsigned int"""
        return _Teuchos.ScalarTraitsUint_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(unsigned int arg0) -> unsigned int"""
        return _Teuchos.ScalarTraitsUint_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsUint_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> unsigned int"""
        return _Teuchos.ScalarTraitsUint_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsUint_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(unsigned int x) -> unsigned int"""
        return _Teuchos.ScalarTraitsUint_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(unsigned int x, unsigned int y) -> unsigned int"""
        return _Teuchos.ScalarTraitsUint_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsUint

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsUint(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsUint
    __del__ = lambda self : None;
ScalarTraitsUint_swigregister = _Teuchos.ScalarTraitsUint_swigregister
ScalarTraitsUint_swigregister(ScalarTraitsUint)

def ScalarTraitsUint_magnitude(*args):
  """ScalarTraitsUint_magnitude(unsigned int a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsUint_magnitude(*args)

def ScalarTraitsUint_zero(*args):
  """ScalarTraitsUint_zero() -> unsigned int"""
  return _Teuchos.ScalarTraitsUint_zero(*args)

def ScalarTraitsUint_one(*args):
  """ScalarTraitsUint_one() -> unsigned int"""
  return _Teuchos.ScalarTraitsUint_one(*args)

def ScalarTraitsUint_conjugate(*args):
  """ScalarTraitsUint_conjugate(unsigned int x) -> unsigned int"""
  return _Teuchos.ScalarTraitsUint_conjugate(*args)

def ScalarTraitsUint_real(*args):
  """ScalarTraitsUint_real(unsigned int x) -> unsigned int"""
  return _Teuchos.ScalarTraitsUint_real(*args)

def ScalarTraitsUint_imag(*args):
  """ScalarTraitsUint_imag(unsigned int arg0) -> unsigned int"""
  return _Teuchos.ScalarTraitsUint_imag(*args)

def ScalarTraitsUint_seedrandom(*args):
  """ScalarTraitsUint_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsUint_seedrandom(*args)

def ScalarTraitsUint_random(*args):
  """ScalarTraitsUint_random() -> unsigned int"""
  return _Teuchos.ScalarTraitsUint_random(*args)

def ScalarTraitsUint_name(*args):
  """ScalarTraitsUint_name() -> string"""
  return _Teuchos.ScalarTraitsUint_name(*args)

def ScalarTraitsUint_squareroot(*args):
  """ScalarTraitsUint_squareroot(unsigned int x) -> unsigned int"""
  return _Teuchos.ScalarTraitsUint_squareroot(*args)

def ScalarTraitsUint_pow(*args):
  """ScalarTraitsUint_pow(unsigned int x, unsigned int y) -> unsigned int"""
  return _Teuchos.ScalarTraitsUint_pow(*args)

class ScalarTraitsLong(_object):
    """ """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsLong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsLong, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsLong_isComplex
    isOrdinal = _Teuchos.ScalarTraitsLong_isOrdinal
    isComparable = _Teuchos.ScalarTraitsLong_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsLong_hasMachineParameters
    def magnitude(*args):
        """magnitude(long a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsLong_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> long"""
        return _Teuchos.ScalarTraitsLong_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> long"""
        return _Teuchos.ScalarTraitsLong_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(long x) -> long"""
        return _Teuchos.ScalarTraitsLong_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(long x) -> long"""
        return _Teuchos.ScalarTraitsLong_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(long arg0) -> long"""
        return _Teuchos.ScalarTraitsLong_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsLong_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> long"""
        return _Teuchos.ScalarTraitsLong_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsLong_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(long x) -> long"""
        return _Teuchos.ScalarTraitsLong_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(long x, long y) -> long"""
        return _Teuchos.ScalarTraitsLong_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsLong

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsLong
    __del__ = lambda self : None;
ScalarTraitsLong_swigregister = _Teuchos.ScalarTraitsLong_swigregister
ScalarTraitsLong_swigregister(ScalarTraitsLong)

def ScalarTraitsLong_magnitude(*args):
  """ScalarTraitsLong_magnitude(long a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsLong_magnitude(*args)

def ScalarTraitsLong_zero(*args):
  """ScalarTraitsLong_zero() -> long"""
  return _Teuchos.ScalarTraitsLong_zero(*args)

def ScalarTraitsLong_one(*args):
  """ScalarTraitsLong_one() -> long"""
  return _Teuchos.ScalarTraitsLong_one(*args)

def ScalarTraitsLong_conjugate(*args):
  """ScalarTraitsLong_conjugate(long x) -> long"""
  return _Teuchos.ScalarTraitsLong_conjugate(*args)

def ScalarTraitsLong_real(*args):
  """ScalarTraitsLong_real(long x) -> long"""
  return _Teuchos.ScalarTraitsLong_real(*args)

def ScalarTraitsLong_imag(*args):
  """ScalarTraitsLong_imag(long arg0) -> long"""
  return _Teuchos.ScalarTraitsLong_imag(*args)

def ScalarTraitsLong_seedrandom(*args):
  """ScalarTraitsLong_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsLong_seedrandom(*args)

def ScalarTraitsLong_random(*args):
  """ScalarTraitsLong_random() -> long"""
  return _Teuchos.ScalarTraitsLong_random(*args)

def ScalarTraitsLong_name(*args):
  """ScalarTraitsLong_name() -> string"""
  return _Teuchos.ScalarTraitsLong_name(*args)

def ScalarTraitsLong_squareroot(*args):
  """ScalarTraitsLong_squareroot(long x) -> long"""
  return _Teuchos.ScalarTraitsLong_squareroot(*args)

def ScalarTraitsLong_pow(*args):
  """ScalarTraitsLong_pow(long x, long y) -> long"""
  return _Teuchos.ScalarTraitsLong_pow(*args)

class ScalarTraitsUlong(_object):
    """ """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsUlong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsUlong, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsUlong_isComplex
    isOrdinal = _Teuchos.ScalarTraitsUlong_isOrdinal
    isComparable = _Teuchos.ScalarTraitsUlong_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsUlong_hasMachineParameters
    def magnitude(*args):
        """magnitude(unsigned long a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsUlong_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> unsigned long"""
        return _Teuchos.ScalarTraitsUlong_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> unsigned long"""
        return _Teuchos.ScalarTraitsUlong_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(unsigned long x) -> unsigned long"""
        return _Teuchos.ScalarTraitsUlong_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(unsigned long x) -> unsigned long"""
        return _Teuchos.ScalarTraitsUlong_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(unsigned long arg0) -> unsigned long"""
        return _Teuchos.ScalarTraitsUlong_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsUlong_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> unsigned long"""
        return _Teuchos.ScalarTraitsUlong_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsUlong_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(unsigned long x) -> unsigned long"""
        return _Teuchos.ScalarTraitsUlong_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(unsigned long x, unsigned long y) -> unsigned long"""
        return _Teuchos.ScalarTraitsUlong_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsUlong

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsUlong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsUlong
    __del__ = lambda self : None;
ScalarTraitsUlong_swigregister = _Teuchos.ScalarTraitsUlong_swigregister
ScalarTraitsUlong_swigregister(ScalarTraitsUlong)

def ScalarTraitsUlong_magnitude(*args):
  """ScalarTraitsUlong_magnitude(unsigned long a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsUlong_magnitude(*args)

def ScalarTraitsUlong_zero(*args):
  """ScalarTraitsUlong_zero() -> unsigned long"""
  return _Teuchos.ScalarTraitsUlong_zero(*args)

def ScalarTraitsUlong_one(*args):
  """ScalarTraitsUlong_one() -> unsigned long"""
  return _Teuchos.ScalarTraitsUlong_one(*args)

def ScalarTraitsUlong_conjugate(*args):
  """ScalarTraitsUlong_conjugate(unsigned long x) -> unsigned long"""
  return _Teuchos.ScalarTraitsUlong_conjugate(*args)

def ScalarTraitsUlong_real(*args):
  """ScalarTraitsUlong_real(unsigned long x) -> unsigned long"""
  return _Teuchos.ScalarTraitsUlong_real(*args)

def ScalarTraitsUlong_imag(*args):
  """ScalarTraitsUlong_imag(unsigned long arg0) -> unsigned long"""
  return _Teuchos.ScalarTraitsUlong_imag(*args)

def ScalarTraitsUlong_seedrandom(*args):
  """ScalarTraitsUlong_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsUlong_seedrandom(*args)

def ScalarTraitsUlong_random(*args):
  """ScalarTraitsUlong_random() -> unsigned long"""
  return _Teuchos.ScalarTraitsUlong_random(*args)

def ScalarTraitsUlong_name(*args):
  """ScalarTraitsUlong_name() -> string"""
  return _Teuchos.ScalarTraitsUlong_name(*args)

def ScalarTraitsUlong_squareroot(*args):
  """ScalarTraitsUlong_squareroot(unsigned long x) -> unsigned long"""
  return _Teuchos.ScalarTraitsUlong_squareroot(*args)

def ScalarTraitsUlong_pow(*args):
  """ScalarTraitsUlong_pow(unsigned long x, unsigned long y) -> unsigned long"""
  return _Teuchos.ScalarTraitsUlong_pow(*args)

class ScalarTraitsLongLong(_object):
    """Proxy of C++ Teuchos::ScalarTraits<(long long)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsLongLong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsLongLong, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsLongLong_isComplex
    isComparable = _Teuchos.ScalarTraitsLongLong_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsLongLong_hasMachineParameters
    def magnitude(*args):
        """magnitude(long long a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsLongLong_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> long long"""
        return _Teuchos.ScalarTraitsLongLong_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> long long"""
        return _Teuchos.ScalarTraitsLongLong_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(long long x) -> long long"""
        return _Teuchos.ScalarTraitsLongLong_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(long long x) -> long long"""
        return _Teuchos.ScalarTraitsLongLong_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(long long x) -> long long"""
        return _Teuchos.ScalarTraitsLongLong_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsLongLong_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> long long"""
        return _Teuchos.ScalarTraitsLongLong_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsLongLong_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(long long x) -> long long"""
        return _Teuchos.ScalarTraitsLongLong_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(long long x, long long y) -> long long"""
        return _Teuchos.ScalarTraitsLongLong_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsLongLong

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsLongLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsLongLong
    __del__ = lambda self : None;
ScalarTraitsLongLong_swigregister = _Teuchos.ScalarTraitsLongLong_swigregister
ScalarTraitsLongLong_swigregister(ScalarTraitsLongLong)

def ScalarTraitsLongLong_magnitude(*args):
  """ScalarTraitsLongLong_magnitude(long long a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsLongLong_magnitude(*args)

def ScalarTraitsLongLong_zero(*args):
  """ScalarTraitsLongLong_zero() -> long long"""
  return _Teuchos.ScalarTraitsLongLong_zero(*args)

def ScalarTraitsLongLong_one(*args):
  """ScalarTraitsLongLong_one() -> long long"""
  return _Teuchos.ScalarTraitsLongLong_one(*args)

def ScalarTraitsLongLong_conjugate(*args):
  """ScalarTraitsLongLong_conjugate(long long x) -> long long"""
  return _Teuchos.ScalarTraitsLongLong_conjugate(*args)

def ScalarTraitsLongLong_real(*args):
  """ScalarTraitsLongLong_real(long long x) -> long long"""
  return _Teuchos.ScalarTraitsLongLong_real(*args)

def ScalarTraitsLongLong_imag(*args):
  """ScalarTraitsLongLong_imag(long long x) -> long long"""
  return _Teuchos.ScalarTraitsLongLong_imag(*args)

def ScalarTraitsLongLong_seedrandom(*args):
  """ScalarTraitsLongLong_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsLongLong_seedrandom(*args)

def ScalarTraitsLongLong_random(*args):
  """ScalarTraitsLongLong_random() -> long long"""
  return _Teuchos.ScalarTraitsLongLong_random(*args)

def ScalarTraitsLongLong_name(*args):
  """ScalarTraitsLongLong_name() -> string"""
  return _Teuchos.ScalarTraitsLongLong_name(*args)

def ScalarTraitsLongLong_squareroot(*args):
  """ScalarTraitsLongLong_squareroot(long long x) -> long long"""
  return _Teuchos.ScalarTraitsLongLong_squareroot(*args)

def ScalarTraitsLongLong_pow(*args):
  """ScalarTraitsLongLong_pow(long long x, long long y) -> long long"""
  return _Teuchos.ScalarTraitsLongLong_pow(*args)

class ScalarTraitsUlongLong(_object):
    """Proxy of C++ Teuchos::ScalarTraits<(unsigned long long)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsUlongLong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsUlongLong, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsUlongLong_isComplex
    isComparable = _Teuchos.ScalarTraitsUlongLong_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsUlongLong_hasMachineParameters
    def magnitude(*args):
        """magnitude(unsigned long long a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsUlongLong_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> unsigned long long"""
        return _Teuchos.ScalarTraitsUlongLong_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> unsigned long long"""
        return _Teuchos.ScalarTraitsUlongLong_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(unsigned long long x) -> unsigned long long"""
        return _Teuchos.ScalarTraitsUlongLong_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(unsigned long long x) -> unsigned long long"""
        return _Teuchos.ScalarTraitsUlongLong_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(unsigned long long x) -> unsigned long long"""
        return _Teuchos.ScalarTraitsUlongLong_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsUlongLong_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> unsigned long long"""
        return _Teuchos.ScalarTraitsUlongLong_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsUlongLong_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(unsigned long long x) -> unsigned long long"""
        return _Teuchos.ScalarTraitsUlongLong_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(unsigned long long x, unsigned long long y) -> unsigned long long"""
        return _Teuchos.ScalarTraitsUlongLong_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsUlongLong

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsUlongLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsUlongLong
    __del__ = lambda self : None;
ScalarTraitsUlongLong_swigregister = _Teuchos.ScalarTraitsUlongLong_swigregister
ScalarTraitsUlongLong_swigregister(ScalarTraitsUlongLong)

def ScalarTraitsUlongLong_magnitude(*args):
  """ScalarTraitsUlongLong_magnitude(unsigned long long a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsUlongLong_magnitude(*args)

def ScalarTraitsUlongLong_zero(*args):
  """ScalarTraitsUlongLong_zero() -> unsigned long long"""
  return _Teuchos.ScalarTraitsUlongLong_zero(*args)

def ScalarTraitsUlongLong_one(*args):
  """ScalarTraitsUlongLong_one() -> unsigned long long"""
  return _Teuchos.ScalarTraitsUlongLong_one(*args)

def ScalarTraitsUlongLong_conjugate(*args):
  """ScalarTraitsUlongLong_conjugate(unsigned long long x) -> unsigned long long"""
  return _Teuchos.ScalarTraitsUlongLong_conjugate(*args)

def ScalarTraitsUlongLong_real(*args):
  """ScalarTraitsUlongLong_real(unsigned long long x) -> unsigned long long"""
  return _Teuchos.ScalarTraitsUlongLong_real(*args)

def ScalarTraitsUlongLong_imag(*args):
  """ScalarTraitsUlongLong_imag(unsigned long long x) -> unsigned long long"""
  return _Teuchos.ScalarTraitsUlongLong_imag(*args)

def ScalarTraitsUlongLong_seedrandom(*args):
  """ScalarTraitsUlongLong_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsUlongLong_seedrandom(*args)

def ScalarTraitsUlongLong_random(*args):
  """ScalarTraitsUlongLong_random() -> unsigned long long"""
  return _Teuchos.ScalarTraitsUlongLong_random(*args)

def ScalarTraitsUlongLong_name(*args):
  """ScalarTraitsUlongLong_name() -> string"""
  return _Teuchos.ScalarTraitsUlongLong_name(*args)

def ScalarTraitsUlongLong_squareroot(*args):
  """ScalarTraitsUlongLong_squareroot(unsigned long long x) -> unsigned long long"""
  return _Teuchos.ScalarTraitsUlongLong_squareroot(*args)

def ScalarTraitsUlongLong_pow(*args):
  """ScalarTraitsUlongLong_pow(unsigned long long x, unsigned long long y) -> unsigned long long"""
  return _Teuchos.ScalarTraitsUlongLong_pow(*args)

class ScalarTraitsFloat(_object):
    """ """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsFloat, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsFloat, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsFloat_isComplex
    isOrdinal = _Teuchos.ScalarTraitsFloat_isOrdinal
    isComparable = _Teuchos.ScalarTraitsFloat_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsFloat_hasMachineParameters
    def eps(*args):
        """eps() -> float"""
        return _Teuchos.ScalarTraitsFloat_eps(*args)

    if _newclass:eps = staticmethod(eps)
    __swig_getmethods__["eps"] = lambda x: eps
    def sfmin(*args):
        """sfmin() -> float"""
        return _Teuchos.ScalarTraitsFloat_sfmin(*args)

    if _newclass:sfmin = staticmethod(sfmin)
    __swig_getmethods__["sfmin"] = lambda x: sfmin
    def base(*args):
        """base() -> float"""
        return _Teuchos.ScalarTraitsFloat_base(*args)

    if _newclass:base = staticmethod(base)
    __swig_getmethods__["base"] = lambda x: base
    def prec(*args):
        """prec() -> float"""
        return _Teuchos.ScalarTraitsFloat_prec(*args)

    if _newclass:prec = staticmethod(prec)
    __swig_getmethods__["prec"] = lambda x: prec
    def t(*args):
        """t() -> float"""
        return _Teuchos.ScalarTraitsFloat_t(*args)

    if _newclass:t = staticmethod(t)
    __swig_getmethods__["t"] = lambda x: t
    def rnd(*args):
        """rnd() -> float"""
        return _Teuchos.ScalarTraitsFloat_rnd(*args)

    if _newclass:rnd = staticmethod(rnd)
    __swig_getmethods__["rnd"] = lambda x: rnd
    def emin(*args):
        """emin() -> float"""
        return _Teuchos.ScalarTraitsFloat_emin(*args)

    if _newclass:emin = staticmethod(emin)
    __swig_getmethods__["emin"] = lambda x: emin
    def rmin(*args):
        """rmin() -> float"""
        return _Teuchos.ScalarTraitsFloat_rmin(*args)

    if _newclass:rmin = staticmethod(rmin)
    __swig_getmethods__["rmin"] = lambda x: rmin
    def emax(*args):
        """emax() -> float"""
        return _Teuchos.ScalarTraitsFloat_emax(*args)

    if _newclass:emax = staticmethod(emax)
    __swig_getmethods__["emax"] = lambda x: emax
    def rmax(*args):
        """rmax() -> float"""
        return _Teuchos.ScalarTraitsFloat_rmax(*args)

    if _newclass:rmax = staticmethod(rmax)
    __swig_getmethods__["rmax"] = lambda x: rmax
    def magnitude(*args):
        """magnitude(float a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsFloat_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> float"""
        return _Teuchos.ScalarTraitsFloat_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> float"""
        return _Teuchos.ScalarTraitsFloat_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(float x) -> float"""
        return _Teuchos.ScalarTraitsFloat_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(float x) -> float"""
        return _Teuchos.ScalarTraitsFloat_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(float arg0) -> float"""
        return _Teuchos.ScalarTraitsFloat_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def nan(*args):
        """nan() -> float"""
        return _Teuchos.ScalarTraitsFloat_nan(*args)

    if _newclass:nan = staticmethod(nan)
    __swig_getmethods__["nan"] = lambda x: nan
    def isnaninf(*args):
        """isnaninf(float x) -> bool"""
        return _Teuchos.ScalarTraitsFloat_isnaninf(*args)

    if _newclass:isnaninf = staticmethod(isnaninf)
    __swig_getmethods__["isnaninf"] = lambda x: isnaninf
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsFloat_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> float"""
        return _Teuchos.ScalarTraitsFloat_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsFloat_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(float x) -> float"""
        return _Teuchos.ScalarTraitsFloat_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(float x, float y) -> float"""
        return _Teuchos.ScalarTraitsFloat_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsFloat

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsFloat(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsFloat
    __del__ = lambda self : None;
ScalarTraitsFloat_swigregister = _Teuchos.ScalarTraitsFloat_swigregister
ScalarTraitsFloat_swigregister(ScalarTraitsFloat)

def ScalarTraitsFloat_eps(*args):
  """ScalarTraitsFloat_eps() -> float"""
  return _Teuchos.ScalarTraitsFloat_eps(*args)

def ScalarTraitsFloat_sfmin(*args):
  """ScalarTraitsFloat_sfmin() -> float"""
  return _Teuchos.ScalarTraitsFloat_sfmin(*args)

def ScalarTraitsFloat_base(*args):
  """ScalarTraitsFloat_base() -> float"""
  return _Teuchos.ScalarTraitsFloat_base(*args)

def ScalarTraitsFloat_prec(*args):
  """ScalarTraitsFloat_prec() -> float"""
  return _Teuchos.ScalarTraitsFloat_prec(*args)

def ScalarTraitsFloat_t(*args):
  """ScalarTraitsFloat_t() -> float"""
  return _Teuchos.ScalarTraitsFloat_t(*args)

def ScalarTraitsFloat_rnd(*args):
  """ScalarTraitsFloat_rnd() -> float"""
  return _Teuchos.ScalarTraitsFloat_rnd(*args)

def ScalarTraitsFloat_emin(*args):
  """ScalarTraitsFloat_emin() -> float"""
  return _Teuchos.ScalarTraitsFloat_emin(*args)

def ScalarTraitsFloat_rmin(*args):
  """ScalarTraitsFloat_rmin() -> float"""
  return _Teuchos.ScalarTraitsFloat_rmin(*args)

def ScalarTraitsFloat_emax(*args):
  """ScalarTraitsFloat_emax() -> float"""
  return _Teuchos.ScalarTraitsFloat_emax(*args)

def ScalarTraitsFloat_rmax(*args):
  """ScalarTraitsFloat_rmax() -> float"""
  return _Teuchos.ScalarTraitsFloat_rmax(*args)

def ScalarTraitsFloat_magnitude(*args):
  """ScalarTraitsFloat_magnitude(float a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsFloat_magnitude(*args)

def ScalarTraitsFloat_zero(*args):
  """ScalarTraitsFloat_zero() -> float"""
  return _Teuchos.ScalarTraitsFloat_zero(*args)

def ScalarTraitsFloat_one(*args):
  """ScalarTraitsFloat_one() -> float"""
  return _Teuchos.ScalarTraitsFloat_one(*args)

def ScalarTraitsFloat_conjugate(*args):
  """ScalarTraitsFloat_conjugate(float x) -> float"""
  return _Teuchos.ScalarTraitsFloat_conjugate(*args)

def ScalarTraitsFloat_real(*args):
  """ScalarTraitsFloat_real(float x) -> float"""
  return _Teuchos.ScalarTraitsFloat_real(*args)

def ScalarTraitsFloat_imag(*args):
  """ScalarTraitsFloat_imag(float arg0) -> float"""
  return _Teuchos.ScalarTraitsFloat_imag(*args)

def ScalarTraitsFloat_nan(*args):
  """ScalarTraitsFloat_nan() -> float"""
  return _Teuchos.ScalarTraitsFloat_nan(*args)

def ScalarTraitsFloat_isnaninf(*args):
  """ScalarTraitsFloat_isnaninf(float x) -> bool"""
  return _Teuchos.ScalarTraitsFloat_isnaninf(*args)

def ScalarTraitsFloat_seedrandom(*args):
  """ScalarTraitsFloat_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsFloat_seedrandom(*args)

def ScalarTraitsFloat_random(*args):
  """ScalarTraitsFloat_random() -> float"""
  return _Teuchos.ScalarTraitsFloat_random(*args)

def ScalarTraitsFloat_name(*args):
  """ScalarTraitsFloat_name() -> string"""
  return _Teuchos.ScalarTraitsFloat_name(*args)

def ScalarTraitsFloat_squareroot(*args):
  """ScalarTraitsFloat_squareroot(float x) -> float"""
  return _Teuchos.ScalarTraitsFloat_squareroot(*args)

def ScalarTraitsFloat_pow(*args):
  """ScalarTraitsFloat_pow(float x, float y) -> float"""
  return _Teuchos.ScalarTraitsFloat_pow(*args)

class ScalarTraitsDouble(_object):
    """ """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ScalarTraitsDouble, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ScalarTraitsDouble, name)
    __repr__ = _swig_repr
    isComplex = _Teuchos.ScalarTraitsDouble_isComplex
    isOrdinal = _Teuchos.ScalarTraitsDouble_isOrdinal
    isComparable = _Teuchos.ScalarTraitsDouble_isComparable
    hasMachineParameters = _Teuchos.ScalarTraitsDouble_hasMachineParameters
    def eps(*args):
        """eps() -> double"""
        return _Teuchos.ScalarTraitsDouble_eps(*args)

    if _newclass:eps = staticmethod(eps)
    __swig_getmethods__["eps"] = lambda x: eps
    def sfmin(*args):
        """sfmin() -> double"""
        return _Teuchos.ScalarTraitsDouble_sfmin(*args)

    if _newclass:sfmin = staticmethod(sfmin)
    __swig_getmethods__["sfmin"] = lambda x: sfmin
    def base(*args):
        """base() -> double"""
        return _Teuchos.ScalarTraitsDouble_base(*args)

    if _newclass:base = staticmethod(base)
    __swig_getmethods__["base"] = lambda x: base
    def prec(*args):
        """prec() -> double"""
        return _Teuchos.ScalarTraitsDouble_prec(*args)

    if _newclass:prec = staticmethod(prec)
    __swig_getmethods__["prec"] = lambda x: prec
    def t(*args):
        """t() -> double"""
        return _Teuchos.ScalarTraitsDouble_t(*args)

    if _newclass:t = staticmethod(t)
    __swig_getmethods__["t"] = lambda x: t
    def rnd(*args):
        """rnd() -> double"""
        return _Teuchos.ScalarTraitsDouble_rnd(*args)

    if _newclass:rnd = staticmethod(rnd)
    __swig_getmethods__["rnd"] = lambda x: rnd
    def emin(*args):
        """emin() -> double"""
        return _Teuchos.ScalarTraitsDouble_emin(*args)

    if _newclass:emin = staticmethod(emin)
    __swig_getmethods__["emin"] = lambda x: emin
    def rmin(*args):
        """rmin() -> double"""
        return _Teuchos.ScalarTraitsDouble_rmin(*args)

    if _newclass:rmin = staticmethod(rmin)
    __swig_getmethods__["rmin"] = lambda x: rmin
    def emax(*args):
        """emax() -> double"""
        return _Teuchos.ScalarTraitsDouble_emax(*args)

    if _newclass:emax = staticmethod(emax)
    __swig_getmethods__["emax"] = lambda x: emax
    def rmax(*args):
        """rmax() -> double"""
        return _Teuchos.ScalarTraitsDouble_rmax(*args)

    if _newclass:rmax = staticmethod(rmax)
    __swig_getmethods__["rmax"] = lambda x: rmax
    def magnitude(*args):
        """magnitude(double a) -> magnitudeType"""
        return _Teuchos.ScalarTraitsDouble_magnitude(*args)

    if _newclass:magnitude = staticmethod(magnitude)
    __swig_getmethods__["magnitude"] = lambda x: magnitude
    def zero(*args):
        """zero() -> double"""
        return _Teuchos.ScalarTraitsDouble_zero(*args)

    if _newclass:zero = staticmethod(zero)
    __swig_getmethods__["zero"] = lambda x: zero
    def one(*args):
        """one() -> double"""
        return _Teuchos.ScalarTraitsDouble_one(*args)

    if _newclass:one = staticmethod(one)
    __swig_getmethods__["one"] = lambda x: one
    def conjugate(*args):
        """conjugate(double x) -> double"""
        return _Teuchos.ScalarTraitsDouble_conjugate(*args)

    if _newclass:conjugate = staticmethod(conjugate)
    __swig_getmethods__["conjugate"] = lambda x: conjugate
    def real(*args):
        """real(double x) -> double"""
        return _Teuchos.ScalarTraitsDouble_real(*args)

    if _newclass:real = staticmethod(real)
    __swig_getmethods__["real"] = lambda x: real
    def imag(*args):
        """imag(double arg0) -> double"""
        return _Teuchos.ScalarTraitsDouble_imag(*args)

    if _newclass:imag = staticmethod(imag)
    __swig_getmethods__["imag"] = lambda x: imag
    def nan(*args):
        """nan() -> double"""
        return _Teuchos.ScalarTraitsDouble_nan(*args)

    if _newclass:nan = staticmethod(nan)
    __swig_getmethods__["nan"] = lambda x: nan
    def isnaninf(*args):
        """isnaninf(double x) -> bool"""
        return _Teuchos.ScalarTraitsDouble_isnaninf(*args)

    if _newclass:isnaninf = staticmethod(isnaninf)
    __swig_getmethods__["isnaninf"] = lambda x: isnaninf
    def seedrandom(*args):
        """seedrandom(unsigned int s)"""
        return _Teuchos.ScalarTraitsDouble_seedrandom(*args)

    if _newclass:seedrandom = staticmethod(seedrandom)
    __swig_getmethods__["seedrandom"] = lambda x: seedrandom
    def random(*args):
        """random() -> double"""
        return _Teuchos.ScalarTraitsDouble_random(*args)

    if _newclass:random = staticmethod(random)
    __swig_getmethods__["random"] = lambda x: random
    def name(*args):
        """name() -> string"""
        return _Teuchos.ScalarTraitsDouble_name(*args)

    if _newclass:name = staticmethod(name)
    __swig_getmethods__["name"] = lambda x: name
    def squareroot(*args):
        """squareroot(double x) -> double"""
        return _Teuchos.ScalarTraitsDouble_squareroot(*args)

    if _newclass:squareroot = staticmethod(squareroot)
    __swig_getmethods__["squareroot"] = lambda x: squareroot
    def pow(*args):
        """pow(double x, double y) -> double"""
        return _Teuchos.ScalarTraitsDouble_pow(*args)

    if _newclass:pow = staticmethod(pow)
    __swig_getmethods__["pow"] = lambda x: pow
    def __init__(self, *args): 
        """
        __init__(self) -> ScalarTraitsDouble

        This structure defines some basic traits for a scalar field type.

        Scalar traits are an essential part of templated codes. This structure
        offers the basic traits of the templated scalar type, like defining
        zero and one, and basic functions on the templated scalar type, like
        performing a square root.

        The functions in the templated base unspecialized struct are designed
        not to compile (giving a nice compile-time error message) and
        therefore specializations must be written for Scalar types actually
        used.

        The default defined specializations are provided for int, float, and
        double.

        ScalarTraits can be used with the Arbitrary Precision Library (
        http://crd.lbl.gov/~dhbailey/mpdist/ ) by configuring Teuchos with
        --enable-teuchos-arprec and giving the appropriate paths to ARPREC.
        Then ScalarTraits has the specialization: mp_real.

        If Teuchos is configured with --enable-teuchos-stdcomplex then
        ScalarTraits also has a parital specialization for all std::complex
        numbers of the form std::complex<T>.

        C++ includes: Teuchos_ScalarTraits.hpp 
        """
        this = _Teuchos.new_ScalarTraitsDouble(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_ScalarTraitsDouble
    __del__ = lambda self : None;
ScalarTraitsDouble_swigregister = _Teuchos.ScalarTraitsDouble_swigregister
ScalarTraitsDouble_swigregister(ScalarTraitsDouble)

def ScalarTraitsDouble_eps(*args):
  """ScalarTraitsDouble_eps() -> double"""
  return _Teuchos.ScalarTraitsDouble_eps(*args)

def ScalarTraitsDouble_sfmin(*args):
  """ScalarTraitsDouble_sfmin() -> double"""
  return _Teuchos.ScalarTraitsDouble_sfmin(*args)

def ScalarTraitsDouble_base(*args):
  """ScalarTraitsDouble_base() -> double"""
  return _Teuchos.ScalarTraitsDouble_base(*args)

def ScalarTraitsDouble_prec(*args):
  """ScalarTraitsDouble_prec() -> double"""
  return _Teuchos.ScalarTraitsDouble_prec(*args)

def ScalarTraitsDouble_t(*args):
  """ScalarTraitsDouble_t() -> double"""
  return _Teuchos.ScalarTraitsDouble_t(*args)

def ScalarTraitsDouble_rnd(*args):
  """ScalarTraitsDouble_rnd() -> double"""
  return _Teuchos.ScalarTraitsDouble_rnd(*args)

def ScalarTraitsDouble_emin(*args):
  """ScalarTraitsDouble_emin() -> double"""
  return _Teuchos.ScalarTraitsDouble_emin(*args)

def ScalarTraitsDouble_rmin(*args):
  """ScalarTraitsDouble_rmin() -> double"""
  return _Teuchos.ScalarTraitsDouble_rmin(*args)

def ScalarTraitsDouble_emax(*args):
  """ScalarTraitsDouble_emax() -> double"""
  return _Teuchos.ScalarTraitsDouble_emax(*args)

def ScalarTraitsDouble_rmax(*args):
  """ScalarTraitsDouble_rmax() -> double"""
  return _Teuchos.ScalarTraitsDouble_rmax(*args)

def ScalarTraitsDouble_magnitude(*args):
  """ScalarTraitsDouble_magnitude(double a) -> magnitudeType"""
  return _Teuchos.ScalarTraitsDouble_magnitude(*args)

def ScalarTraitsDouble_zero(*args):
  """ScalarTraitsDouble_zero() -> double"""
  return _Teuchos.ScalarTraitsDouble_zero(*args)

def ScalarTraitsDouble_one(*args):
  """ScalarTraitsDouble_one() -> double"""
  return _Teuchos.ScalarTraitsDouble_one(*args)

def ScalarTraitsDouble_conjugate(*args):
  """ScalarTraitsDouble_conjugate(double x) -> double"""
  return _Teuchos.ScalarTraitsDouble_conjugate(*args)

def ScalarTraitsDouble_real(*args):
  """ScalarTraitsDouble_real(double x) -> double"""
  return _Teuchos.ScalarTraitsDouble_real(*args)

def ScalarTraitsDouble_imag(*args):
  """ScalarTraitsDouble_imag(double arg0) -> double"""
  return _Teuchos.ScalarTraitsDouble_imag(*args)

def ScalarTraitsDouble_nan(*args):
  """ScalarTraitsDouble_nan() -> double"""
  return _Teuchos.ScalarTraitsDouble_nan(*args)

def ScalarTraitsDouble_isnaninf(*args):
  """ScalarTraitsDouble_isnaninf(double x) -> bool"""
  return _Teuchos.ScalarTraitsDouble_isnaninf(*args)

def ScalarTraitsDouble_seedrandom(*args):
  """ScalarTraitsDouble_seedrandom(unsigned int s)"""
  return _Teuchos.ScalarTraitsDouble_seedrandom(*args)

def ScalarTraitsDouble_random(*args):
  """ScalarTraitsDouble_random() -> double"""
  return _Teuchos.ScalarTraitsDouble_random(*args)

def ScalarTraitsDouble_name(*args):
  """ScalarTraitsDouble_name() -> string"""
  return _Teuchos.ScalarTraitsDouble_name(*args)

def ScalarTraitsDouble_squareroot(*args):
  """ScalarTraitsDouble_squareroot(double x) -> double"""
  return _Teuchos.ScalarTraitsDouble_squareroot(*args)

def ScalarTraitsDouble_pow(*args):
  """ScalarTraitsDouble_pow(double x, double y) -> double"""
  return _Teuchos.ScalarTraitsDouble_pow(*args)

def ScalarTraits(scalarType):
    """
    ScalarTraits(str scalarType) -> ScalarTraits<...>

    The scalarType argument is for specifying the type of scalar for
    which traits are requested.  Limited NumPy-style type
    specification is supported:

        'b'  byte
        'B'  unsigned byte
        'h'  short
        'H'  unsigned short
        'i'  int
        'I'  unsigned int
        'l'  long
        'L'  unsigned long
        'q'  long long
        'Q'  unsigned long long
        'f'  float
        'd'  double
    """
    if   scalarType == 'b': return ScalarTraitsByte()
    elif scalarType == 'B': return ScalarTraitsUbyte()
    elif scalarType == 'h': return ScalarTraitsShort()
    elif scalarType == 'H': return ScalarTraitsUshort()
    elif scalarType == 'i': return ScalarTraitsInt()
    elif scalarType == 'I': return ScalarTraitsUint()
    elif scalarType == 'l': return ScalarTraitsLong()
    elif scalarType == 'L': return ScalarTraitsUlong()
    elif scalarType == 'q': return ScalarTraitsLongLong()
    elif scalarType == 'Q': return ScalarTraitsUlongLong()
    elif scalarType == 'f': return ScalarTraitsFloat()
    elif scalarType == 'd': return ScalarTraitsDouble()
    raise NotImplementedError, "ScalarTraits for " + repr(scalarType) + " not supported"

class DirectSerializationTraitsByte(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,char)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsByte, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsByte, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsByte_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsByte_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(char ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsByte_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsByte_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsByte_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsByte_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, char buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsByte_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsByte_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, char buffer)"""
        return _Teuchos.DirectSerializationTraitsByte_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsByte"""
        this = _Teuchos.new_DirectSerializationTraitsByte(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsByte
    __del__ = lambda self : None;
DirectSerializationTraitsByte_swigregister = _Teuchos.DirectSerializationTraitsByte_swigregister
DirectSerializationTraitsByte_swigregister(DirectSerializationTraitsByte)

def DirectSerializationTraitsByte_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsByte_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsByte_fromCountToDirectBytes(*args)

def DirectSerializationTraitsByte_convertToCharPtr(*args):
  """DirectSerializationTraitsByte_convertToCharPtr(char ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsByte_convertToCharPtr(*args)

def DirectSerializationTraitsByte_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsByte_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsByte_fromDirectBytesToCount(*args)

def DirectSerializationTraitsByte_convertFromCharPtr(*args):
  """DirectSerializationTraitsByte_convertFromCharPtr(char ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsByte_convertFromCharPtr(*args)

def DirectSerializationTraitsByte_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsByte_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsByte_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsByte_serialize(*args):
  """DirectSerializationTraitsByte_serialize(long count, char buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsByte_serialize(*args)

def DirectSerializationTraitsByte_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsByte_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsByte_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsByte_deserialize(*args):
  """DirectSerializationTraitsByte_deserialize(long bytes, char charBuffer, long count, char buffer)"""
  return _Teuchos.DirectSerializationTraitsByte_deserialize(*args)

class SerializationTraitsByte(DirectSerializationTraitsByte):
    """Proxy of C++ Teuchos::SerializationTraits<(long,char)> class"""
    __swig_setmethods__ = {}
    for _s in [DirectSerializationTraitsByte]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsByte, name, value)
    __swig_getmethods__ = {}
    for _s in [DirectSerializationTraitsByte]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsByte, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsByte"""
        this = _Teuchos.new_SerializationTraitsByte(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsByte
    __del__ = lambda self : None;
SerializationTraitsByte_swigregister = _Teuchos.SerializationTraitsByte_swigregister
SerializationTraitsByte_swigregister(SerializationTraitsByte)

class DirectSerializationTraitsUbyte(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,unsigned char)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsUbyte, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsUbyte, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsUbyte_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUbyte_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(unsigned char ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsUbyte_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUbyte_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> unsigned char"""
        return _Teuchos.DirectSerializationTraitsUbyte_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUbyte_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, unsigned char buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsUbyte_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsUbyte_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, unsigned char buffer)"""
        return _Teuchos.DirectSerializationTraitsUbyte_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsUbyte"""
        this = _Teuchos.new_DirectSerializationTraitsUbyte(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsUbyte
    __del__ = lambda self : None;
DirectSerializationTraitsUbyte_swigregister = _Teuchos.DirectSerializationTraitsUbyte_swigregister
DirectSerializationTraitsUbyte_swigregister(DirectSerializationTraitsUbyte)

def DirectSerializationTraitsUbyte_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsUbyte_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUbyte_fromCountToDirectBytes(*args)

def DirectSerializationTraitsUbyte_convertToCharPtr(*args):
  """DirectSerializationTraitsUbyte_convertToCharPtr(unsigned char ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsUbyte_convertToCharPtr(*args)

def DirectSerializationTraitsUbyte_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsUbyte_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUbyte_fromDirectBytesToCount(*args)

def DirectSerializationTraitsUbyte_convertFromCharPtr(*args):
  """DirectSerializationTraitsUbyte_convertFromCharPtr(char ptr) -> unsigned char"""
  return _Teuchos.DirectSerializationTraitsUbyte_convertFromCharPtr(*args)

def DirectSerializationTraitsUbyte_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsUbyte_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUbyte_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsUbyte_serialize(*args):
  """DirectSerializationTraitsUbyte_serialize(long count, unsigned char buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsUbyte_serialize(*args)

def DirectSerializationTraitsUbyte_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsUbyte_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsUbyte_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsUbyte_deserialize(*args):
  """DirectSerializationTraitsUbyte_deserialize(long bytes, char charBuffer, long count, unsigned char buffer)"""
  return _Teuchos.DirectSerializationTraitsUbyte_deserialize(*args)

class SerializationTraitsUbyte(_object):
    """Proxy of C++ Teuchos::SerializationTraits<(long,unsigned char)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsUbyte, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsUbyte, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.SerializationTraitsUbyte_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.SerializationTraitsUbyte_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(unsigned char ptr) -> char"""
        return _Teuchos.SerializationTraitsUbyte_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long bytes) -> long"""
        return _Teuchos.SerializationTraitsUbyte_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> unsigned char"""
        return _Teuchos.SerializationTraitsUbyte_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.SerializationTraitsUbyte_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, unsigned char buffer, long bytes, char charBuffer)"""
        return _Teuchos.SerializationTraitsUbyte_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.SerializationTraitsUbyte_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, unsigned char buffer)"""
        return _Teuchos.SerializationTraitsUbyte_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsUbyte"""
        this = _Teuchos.new_SerializationTraitsUbyte(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsUbyte
    __del__ = lambda self : None;
SerializationTraitsUbyte_swigregister = _Teuchos.SerializationTraitsUbyte_swigregister
SerializationTraitsUbyte_swigregister(SerializationTraitsUbyte)

def SerializationTraitsUbyte_fromCountToDirectBytes(*args):
  """SerializationTraitsUbyte_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.SerializationTraitsUbyte_fromCountToDirectBytes(*args)

def SerializationTraitsUbyte_convertToCharPtr(*args):
  """SerializationTraitsUbyte_convertToCharPtr(unsigned char ptr) -> char"""
  return _Teuchos.SerializationTraitsUbyte_convertToCharPtr(*args)

def SerializationTraitsUbyte_fromDirectBytesToCount(*args):
  """SerializationTraitsUbyte_fromDirectBytesToCount(long bytes) -> long"""
  return _Teuchos.SerializationTraitsUbyte_fromDirectBytesToCount(*args)

def SerializationTraitsUbyte_convertFromCharPtr(*args):
  """SerializationTraitsUbyte_convertFromCharPtr(char ptr) -> unsigned char"""
  return _Teuchos.SerializationTraitsUbyte_convertFromCharPtr(*args)

def SerializationTraitsUbyte_fromCountToIndirectBytes(*args):
  """SerializationTraitsUbyte_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.SerializationTraitsUbyte_fromCountToIndirectBytes(*args)

def SerializationTraitsUbyte_serialize(*args):
  """SerializationTraitsUbyte_serialize(long count, unsigned char buffer, long bytes, char charBuffer)"""
  return _Teuchos.SerializationTraitsUbyte_serialize(*args)

def SerializationTraitsUbyte_fromIndirectBytesToCount(*args):
  """SerializationTraitsUbyte_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.SerializationTraitsUbyte_fromIndirectBytesToCount(*args)

def SerializationTraitsUbyte_deserialize(*args):
  """SerializationTraitsUbyte_deserialize(long bytes, char charBuffer, long count, unsigned char buffer)"""
  return _Teuchos.SerializationTraitsUbyte_deserialize(*args)

class DirectSerializationTraitsShort(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,short)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsShort, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsShort, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsShort_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsShort_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(short ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsShort_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsShort_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> short"""
        return _Teuchos.DirectSerializationTraitsShort_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsShort_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, short buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsShort_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsShort_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, short buffer)"""
        return _Teuchos.DirectSerializationTraitsShort_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsShort"""
        this = _Teuchos.new_DirectSerializationTraitsShort(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsShort
    __del__ = lambda self : None;
DirectSerializationTraitsShort_swigregister = _Teuchos.DirectSerializationTraitsShort_swigregister
DirectSerializationTraitsShort_swigregister(DirectSerializationTraitsShort)

def DirectSerializationTraitsShort_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsShort_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsShort_fromCountToDirectBytes(*args)

def DirectSerializationTraitsShort_convertToCharPtr(*args):
  """DirectSerializationTraitsShort_convertToCharPtr(short ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsShort_convertToCharPtr(*args)

def DirectSerializationTraitsShort_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsShort_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsShort_fromDirectBytesToCount(*args)

def DirectSerializationTraitsShort_convertFromCharPtr(*args):
  """DirectSerializationTraitsShort_convertFromCharPtr(char ptr) -> short"""
  return _Teuchos.DirectSerializationTraitsShort_convertFromCharPtr(*args)

def DirectSerializationTraitsShort_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsShort_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsShort_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsShort_serialize(*args):
  """DirectSerializationTraitsShort_serialize(long count, short buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsShort_serialize(*args)

def DirectSerializationTraitsShort_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsShort_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsShort_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsShort_deserialize(*args):
  """DirectSerializationTraitsShort_deserialize(long bytes, char charBuffer, long count, short buffer)"""
  return _Teuchos.DirectSerializationTraitsShort_deserialize(*args)

class SerializationTraitsShort(DirectSerializationTraitsShort):
    """Proxy of C++ Teuchos::SerializationTraits<(long,short)> class"""
    __swig_setmethods__ = {}
    for _s in [DirectSerializationTraitsShort]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsShort, name, value)
    __swig_getmethods__ = {}
    for _s in [DirectSerializationTraitsShort]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsShort, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsShort"""
        this = _Teuchos.new_SerializationTraitsShort(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsShort
    __del__ = lambda self : None;
SerializationTraitsShort_swigregister = _Teuchos.SerializationTraitsShort_swigregister
SerializationTraitsShort_swigregister(SerializationTraitsShort)

class DirectSerializationTraitsUshort(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,unsigned short)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsUshort, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsUshort, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsUshort_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUshort_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(unsigned short ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsUshort_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUshort_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> unsigned short"""
        return _Teuchos.DirectSerializationTraitsUshort_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUshort_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, unsigned short buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsUshort_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsUshort_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, unsigned short buffer)"""
        return _Teuchos.DirectSerializationTraitsUshort_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsUshort"""
        this = _Teuchos.new_DirectSerializationTraitsUshort(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsUshort
    __del__ = lambda self : None;
DirectSerializationTraitsUshort_swigregister = _Teuchos.DirectSerializationTraitsUshort_swigregister
DirectSerializationTraitsUshort_swigregister(DirectSerializationTraitsUshort)

def DirectSerializationTraitsUshort_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsUshort_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUshort_fromCountToDirectBytes(*args)

def DirectSerializationTraitsUshort_convertToCharPtr(*args):
  """DirectSerializationTraitsUshort_convertToCharPtr(unsigned short ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsUshort_convertToCharPtr(*args)

def DirectSerializationTraitsUshort_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsUshort_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUshort_fromDirectBytesToCount(*args)

def DirectSerializationTraitsUshort_convertFromCharPtr(*args):
  """DirectSerializationTraitsUshort_convertFromCharPtr(char ptr) -> unsigned short"""
  return _Teuchos.DirectSerializationTraitsUshort_convertFromCharPtr(*args)

def DirectSerializationTraitsUshort_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsUshort_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUshort_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsUshort_serialize(*args):
  """DirectSerializationTraitsUshort_serialize(long count, unsigned short buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsUshort_serialize(*args)

def DirectSerializationTraitsUshort_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsUshort_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsUshort_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsUshort_deserialize(*args):
  """DirectSerializationTraitsUshort_deserialize(long bytes, char charBuffer, long count, unsigned short buffer)"""
  return _Teuchos.DirectSerializationTraitsUshort_deserialize(*args)

class SerializationTraitsUshort(_object):
    """Proxy of C++ Teuchos::SerializationTraits<(long,unsigned short)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsUshort, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsUshort, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.SerializationTraitsUshort_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.SerializationTraitsUshort_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(unsigned short ptr) -> char"""
        return _Teuchos.SerializationTraitsUshort_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long bytes) -> long"""
        return _Teuchos.SerializationTraitsUshort_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> unsigned short"""
        return _Teuchos.SerializationTraitsUshort_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.SerializationTraitsUshort_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, unsigned short buffer, long bytes, char charBuffer)"""
        return _Teuchos.SerializationTraitsUshort_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.SerializationTraitsUshort_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, unsigned short buffer)"""
        return _Teuchos.SerializationTraitsUshort_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsUshort"""
        this = _Teuchos.new_SerializationTraitsUshort(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsUshort
    __del__ = lambda self : None;
SerializationTraitsUshort_swigregister = _Teuchos.SerializationTraitsUshort_swigregister
SerializationTraitsUshort_swigregister(SerializationTraitsUshort)

def SerializationTraitsUshort_fromCountToDirectBytes(*args):
  """SerializationTraitsUshort_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.SerializationTraitsUshort_fromCountToDirectBytes(*args)

def SerializationTraitsUshort_convertToCharPtr(*args):
  """SerializationTraitsUshort_convertToCharPtr(unsigned short ptr) -> char"""
  return _Teuchos.SerializationTraitsUshort_convertToCharPtr(*args)

def SerializationTraitsUshort_fromDirectBytesToCount(*args):
  """SerializationTraitsUshort_fromDirectBytesToCount(long bytes) -> long"""
  return _Teuchos.SerializationTraitsUshort_fromDirectBytesToCount(*args)

def SerializationTraitsUshort_convertFromCharPtr(*args):
  """SerializationTraitsUshort_convertFromCharPtr(char ptr) -> unsigned short"""
  return _Teuchos.SerializationTraitsUshort_convertFromCharPtr(*args)

def SerializationTraitsUshort_fromCountToIndirectBytes(*args):
  """SerializationTraitsUshort_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.SerializationTraitsUshort_fromCountToIndirectBytes(*args)

def SerializationTraitsUshort_serialize(*args):
  """SerializationTraitsUshort_serialize(long count, unsigned short buffer, long bytes, char charBuffer)"""
  return _Teuchos.SerializationTraitsUshort_serialize(*args)

def SerializationTraitsUshort_fromIndirectBytesToCount(*args):
  """SerializationTraitsUshort_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.SerializationTraitsUshort_fromIndirectBytesToCount(*args)

def SerializationTraitsUshort_deserialize(*args):
  """SerializationTraitsUshort_deserialize(long bytes, char charBuffer, long count, unsigned short buffer)"""
  return _Teuchos.SerializationTraitsUshort_deserialize(*args)

class DirectSerializationTraitsInt(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,int)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsInt, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsInt, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsInt_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsInt_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(int ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsInt_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsInt_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> int"""
        return _Teuchos.DirectSerializationTraitsInt_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsInt_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, int buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsInt_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsInt_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, int buffer)"""
        return _Teuchos.DirectSerializationTraitsInt_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsInt"""
        this = _Teuchos.new_DirectSerializationTraitsInt(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsInt
    __del__ = lambda self : None;
DirectSerializationTraitsInt_swigregister = _Teuchos.DirectSerializationTraitsInt_swigregister
DirectSerializationTraitsInt_swigregister(DirectSerializationTraitsInt)

def DirectSerializationTraitsInt_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsInt_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsInt_fromCountToDirectBytes(*args)

def DirectSerializationTraitsInt_convertToCharPtr(*args):
  """DirectSerializationTraitsInt_convertToCharPtr(int ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsInt_convertToCharPtr(*args)

def DirectSerializationTraitsInt_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsInt_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsInt_fromDirectBytesToCount(*args)

def DirectSerializationTraitsInt_convertFromCharPtr(*args):
  """DirectSerializationTraitsInt_convertFromCharPtr(char ptr) -> int"""
  return _Teuchos.DirectSerializationTraitsInt_convertFromCharPtr(*args)

def DirectSerializationTraitsInt_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsInt_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsInt_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsInt_serialize(*args):
  """DirectSerializationTraitsInt_serialize(long count, int buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsInt_serialize(*args)

def DirectSerializationTraitsInt_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsInt_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsInt_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsInt_deserialize(*args):
  """DirectSerializationTraitsInt_deserialize(long bytes, char charBuffer, long count, int buffer)"""
  return _Teuchos.DirectSerializationTraitsInt_deserialize(*args)

class SerializationTraitsInt(DirectSerializationTraitsInt):
    """Proxy of C++ Teuchos::SerializationTraits<(long,int)> class"""
    __swig_setmethods__ = {}
    for _s in [DirectSerializationTraitsInt]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsInt, name, value)
    __swig_getmethods__ = {}
    for _s in [DirectSerializationTraitsInt]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsInt, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsInt"""
        this = _Teuchos.new_SerializationTraitsInt(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsInt
    __del__ = lambda self : None;
SerializationTraitsInt_swigregister = _Teuchos.SerializationTraitsInt_swigregister
SerializationTraitsInt_swigregister(SerializationTraitsInt)

class DirectSerializationTraitsUint(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,unsigned int)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsUint, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsUint, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsUint_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUint_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(unsigned int ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsUint_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUint_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> unsigned int"""
        return _Teuchos.DirectSerializationTraitsUint_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUint_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, unsigned int buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsUint_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsUint_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, unsigned int buffer)"""
        return _Teuchos.DirectSerializationTraitsUint_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsUint"""
        this = _Teuchos.new_DirectSerializationTraitsUint(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsUint
    __del__ = lambda self : None;
DirectSerializationTraitsUint_swigregister = _Teuchos.DirectSerializationTraitsUint_swigregister
DirectSerializationTraitsUint_swigregister(DirectSerializationTraitsUint)

def DirectSerializationTraitsUint_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsUint_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUint_fromCountToDirectBytes(*args)

def DirectSerializationTraitsUint_convertToCharPtr(*args):
  """DirectSerializationTraitsUint_convertToCharPtr(unsigned int ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsUint_convertToCharPtr(*args)

def DirectSerializationTraitsUint_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsUint_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUint_fromDirectBytesToCount(*args)

def DirectSerializationTraitsUint_convertFromCharPtr(*args):
  """DirectSerializationTraitsUint_convertFromCharPtr(char ptr) -> unsigned int"""
  return _Teuchos.DirectSerializationTraitsUint_convertFromCharPtr(*args)

def DirectSerializationTraitsUint_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsUint_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUint_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsUint_serialize(*args):
  """DirectSerializationTraitsUint_serialize(long count, unsigned int buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsUint_serialize(*args)

def DirectSerializationTraitsUint_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsUint_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsUint_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsUint_deserialize(*args):
  """DirectSerializationTraitsUint_deserialize(long bytes, char charBuffer, long count, unsigned int buffer)"""
  return _Teuchos.DirectSerializationTraitsUint_deserialize(*args)

class SerializationTraitsUint(DirectSerializationTraitsUint):
    """Proxy of C++ Teuchos::SerializationTraits<(long,unsigned int)> class"""
    __swig_setmethods__ = {}
    for _s in [DirectSerializationTraitsUint]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsUint, name, value)
    __swig_getmethods__ = {}
    for _s in [DirectSerializationTraitsUint]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsUint, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsUint"""
        this = _Teuchos.new_SerializationTraitsUint(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsUint
    __del__ = lambda self : None;
SerializationTraitsUint_swigregister = _Teuchos.SerializationTraitsUint_swigregister
SerializationTraitsUint_swigregister(SerializationTraitsUint)

class DirectSerializationTraitsLong(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,long)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsLong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsLong, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsLong_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsLong_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(long ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsLong_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsLong_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> long"""
        return _Teuchos.DirectSerializationTraitsLong_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsLong_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, long buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsLong_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsLong_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, long buffer)"""
        return _Teuchos.DirectSerializationTraitsLong_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsLong"""
        this = _Teuchos.new_DirectSerializationTraitsLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsLong
    __del__ = lambda self : None;
DirectSerializationTraitsLong_swigregister = _Teuchos.DirectSerializationTraitsLong_swigregister
DirectSerializationTraitsLong_swigregister(DirectSerializationTraitsLong)

def DirectSerializationTraitsLong_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsLong_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsLong_fromCountToDirectBytes(*args)

def DirectSerializationTraitsLong_convertToCharPtr(*args):
  """DirectSerializationTraitsLong_convertToCharPtr(long ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsLong_convertToCharPtr(*args)

def DirectSerializationTraitsLong_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsLong_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsLong_fromDirectBytesToCount(*args)

def DirectSerializationTraitsLong_convertFromCharPtr(*args):
  """DirectSerializationTraitsLong_convertFromCharPtr(char ptr) -> long"""
  return _Teuchos.DirectSerializationTraitsLong_convertFromCharPtr(*args)

def DirectSerializationTraitsLong_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsLong_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsLong_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsLong_serialize(*args):
  """DirectSerializationTraitsLong_serialize(long count, long buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsLong_serialize(*args)

def DirectSerializationTraitsLong_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsLong_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsLong_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsLong_deserialize(*args):
  """DirectSerializationTraitsLong_deserialize(long bytes, char charBuffer, long count, long buffer)"""
  return _Teuchos.DirectSerializationTraitsLong_deserialize(*args)

class SerializationTraitsLong(DirectSerializationTraitsLong):
    """Proxy of C++ Teuchos::SerializationTraits<(long,long)> class"""
    __swig_setmethods__ = {}
    for _s in [DirectSerializationTraitsLong]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsLong, name, value)
    __swig_getmethods__ = {}
    for _s in [DirectSerializationTraitsLong]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsLong, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsLong"""
        this = _Teuchos.new_SerializationTraitsLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsLong
    __del__ = lambda self : None;
SerializationTraitsLong_swigregister = _Teuchos.SerializationTraitsLong_swigregister
SerializationTraitsLong_swigregister(SerializationTraitsLong)

class DirectSerializationTraitsUlong(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,unsigned long)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsUlong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsUlong, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsUlong_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUlong_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(unsigned long ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsUlong_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUlong_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> unsigned long"""
        return _Teuchos.DirectSerializationTraitsUlong_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUlong_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, unsigned long buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsUlong_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsUlong_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, unsigned long buffer)"""
        return _Teuchos.DirectSerializationTraitsUlong_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsUlong"""
        this = _Teuchos.new_DirectSerializationTraitsUlong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsUlong
    __del__ = lambda self : None;
DirectSerializationTraitsUlong_swigregister = _Teuchos.DirectSerializationTraitsUlong_swigregister
DirectSerializationTraitsUlong_swigregister(DirectSerializationTraitsUlong)

def DirectSerializationTraitsUlong_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsUlong_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUlong_fromCountToDirectBytes(*args)

def DirectSerializationTraitsUlong_convertToCharPtr(*args):
  """DirectSerializationTraitsUlong_convertToCharPtr(unsigned long ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsUlong_convertToCharPtr(*args)

def DirectSerializationTraitsUlong_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsUlong_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUlong_fromDirectBytesToCount(*args)

def DirectSerializationTraitsUlong_convertFromCharPtr(*args):
  """DirectSerializationTraitsUlong_convertFromCharPtr(char ptr) -> unsigned long"""
  return _Teuchos.DirectSerializationTraitsUlong_convertFromCharPtr(*args)

def DirectSerializationTraitsUlong_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsUlong_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUlong_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsUlong_serialize(*args):
  """DirectSerializationTraitsUlong_serialize(long count, unsigned long buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsUlong_serialize(*args)

def DirectSerializationTraitsUlong_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsUlong_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsUlong_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsUlong_deserialize(*args):
  """DirectSerializationTraitsUlong_deserialize(long bytes, char charBuffer, long count, unsigned long buffer)"""
  return _Teuchos.DirectSerializationTraitsUlong_deserialize(*args)

class SerializationTraitsUlong(DirectSerializationTraitsUlong):
    """Proxy of C++ Teuchos::SerializationTraits<(long,unsigned long)> class"""
    __swig_setmethods__ = {}
    for _s in [DirectSerializationTraitsUlong]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsUlong, name, value)
    __swig_getmethods__ = {}
    for _s in [DirectSerializationTraitsUlong]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsUlong, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsUlong"""
        this = _Teuchos.new_SerializationTraitsUlong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsUlong
    __del__ = lambda self : None;
SerializationTraitsUlong_swigregister = _Teuchos.SerializationTraitsUlong_swigregister
SerializationTraitsUlong_swigregister(SerializationTraitsUlong)

class DirectSerializationTraitsLongLong(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,long long)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsLongLong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsLongLong, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsLongLong_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsLongLong_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(long long ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsLongLong_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsLongLong_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> long long"""
        return _Teuchos.DirectSerializationTraitsLongLong_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsLongLong_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, long long buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsLongLong_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsLongLong_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, long long buffer)"""
        return _Teuchos.DirectSerializationTraitsLongLong_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsLongLong"""
        this = _Teuchos.new_DirectSerializationTraitsLongLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsLongLong
    __del__ = lambda self : None;
DirectSerializationTraitsLongLong_swigregister = _Teuchos.DirectSerializationTraitsLongLong_swigregister
DirectSerializationTraitsLongLong_swigregister(DirectSerializationTraitsLongLong)

def DirectSerializationTraitsLongLong_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsLongLong_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsLongLong_fromCountToDirectBytes(*args)

def DirectSerializationTraitsLongLong_convertToCharPtr(*args):
  """DirectSerializationTraitsLongLong_convertToCharPtr(long long ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsLongLong_convertToCharPtr(*args)

def DirectSerializationTraitsLongLong_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsLongLong_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsLongLong_fromDirectBytesToCount(*args)

def DirectSerializationTraitsLongLong_convertFromCharPtr(*args):
  """DirectSerializationTraitsLongLong_convertFromCharPtr(char ptr) -> long long"""
  return _Teuchos.DirectSerializationTraitsLongLong_convertFromCharPtr(*args)

def DirectSerializationTraitsLongLong_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsLongLong_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsLongLong_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsLongLong_serialize(*args):
  """DirectSerializationTraitsLongLong_serialize(long count, long long buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsLongLong_serialize(*args)

def DirectSerializationTraitsLongLong_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsLongLong_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsLongLong_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsLongLong_deserialize(*args):
  """DirectSerializationTraitsLongLong_deserialize(long bytes, char charBuffer, long count, long long buffer)"""
  return _Teuchos.DirectSerializationTraitsLongLong_deserialize(*args)

class SerializationTraitsLongLong(_object):
    """Proxy of C++ Teuchos::SerializationTraits<(long,long long)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsLongLong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsLongLong, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.SerializationTraitsLongLong_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.SerializationTraitsLongLong_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(long long ptr) -> char"""
        return _Teuchos.SerializationTraitsLongLong_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long bytes) -> long"""
        return _Teuchos.SerializationTraitsLongLong_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> long long"""
        return _Teuchos.SerializationTraitsLongLong_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.SerializationTraitsLongLong_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, long long buffer, long bytes, char charBuffer)"""
        return _Teuchos.SerializationTraitsLongLong_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.SerializationTraitsLongLong_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, long long buffer)"""
        return _Teuchos.SerializationTraitsLongLong_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsLongLong"""
        this = _Teuchos.new_SerializationTraitsLongLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsLongLong
    __del__ = lambda self : None;
SerializationTraitsLongLong_swigregister = _Teuchos.SerializationTraitsLongLong_swigregister
SerializationTraitsLongLong_swigregister(SerializationTraitsLongLong)

def SerializationTraitsLongLong_fromCountToDirectBytes(*args):
  """SerializationTraitsLongLong_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.SerializationTraitsLongLong_fromCountToDirectBytes(*args)

def SerializationTraitsLongLong_convertToCharPtr(*args):
  """SerializationTraitsLongLong_convertToCharPtr(long long ptr) -> char"""
  return _Teuchos.SerializationTraitsLongLong_convertToCharPtr(*args)

def SerializationTraitsLongLong_fromDirectBytesToCount(*args):
  """SerializationTraitsLongLong_fromDirectBytesToCount(long bytes) -> long"""
  return _Teuchos.SerializationTraitsLongLong_fromDirectBytesToCount(*args)

def SerializationTraitsLongLong_convertFromCharPtr(*args):
  """SerializationTraitsLongLong_convertFromCharPtr(char ptr) -> long long"""
  return _Teuchos.SerializationTraitsLongLong_convertFromCharPtr(*args)

def SerializationTraitsLongLong_fromCountToIndirectBytes(*args):
  """SerializationTraitsLongLong_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.SerializationTraitsLongLong_fromCountToIndirectBytes(*args)

def SerializationTraitsLongLong_serialize(*args):
  """SerializationTraitsLongLong_serialize(long count, long long buffer, long bytes, char charBuffer)"""
  return _Teuchos.SerializationTraitsLongLong_serialize(*args)

def SerializationTraitsLongLong_fromIndirectBytesToCount(*args):
  """SerializationTraitsLongLong_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.SerializationTraitsLongLong_fromIndirectBytesToCount(*args)

def SerializationTraitsLongLong_deserialize(*args):
  """SerializationTraitsLongLong_deserialize(long bytes, char charBuffer, long count, long long buffer)"""
  return _Teuchos.SerializationTraitsLongLong_deserialize(*args)

class DirectSerializationTraitsUlongLong(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,unsigned long long)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsUlongLong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsUlongLong, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsUlongLong_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUlongLong_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(unsigned long long ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsUlongLong_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUlongLong_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> unsigned long long"""
        return _Teuchos.DirectSerializationTraitsUlongLong_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsUlongLong_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """
        serialize(long count, unsigned long long buffer, long bytes, 
            char charBuffer)
        """
        return _Teuchos.DirectSerializationTraitsUlongLong_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsUlongLong_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, unsigned long long buffer)"""
        return _Teuchos.DirectSerializationTraitsUlongLong_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsUlongLong"""
        this = _Teuchos.new_DirectSerializationTraitsUlongLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsUlongLong
    __del__ = lambda self : None;
DirectSerializationTraitsUlongLong_swigregister = _Teuchos.DirectSerializationTraitsUlongLong_swigregister
DirectSerializationTraitsUlongLong_swigregister(DirectSerializationTraitsUlongLong)

def DirectSerializationTraitsUlongLong_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsUlongLong_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUlongLong_fromCountToDirectBytes(*args)

def DirectSerializationTraitsUlongLong_convertToCharPtr(*args):
  """DirectSerializationTraitsUlongLong_convertToCharPtr(unsigned long long ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsUlongLong_convertToCharPtr(*args)

def DirectSerializationTraitsUlongLong_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsUlongLong_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUlongLong_fromDirectBytesToCount(*args)

def DirectSerializationTraitsUlongLong_convertFromCharPtr(*args):
  """DirectSerializationTraitsUlongLong_convertFromCharPtr(char ptr) -> unsigned long long"""
  return _Teuchos.DirectSerializationTraitsUlongLong_convertFromCharPtr(*args)

def DirectSerializationTraitsUlongLong_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsUlongLong_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsUlongLong_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsUlongLong_serialize(*args):
  """
    DirectSerializationTraitsUlongLong_serialize(long count, unsigned long long buffer, long bytes, 
        char charBuffer)
    """
  return _Teuchos.DirectSerializationTraitsUlongLong_serialize(*args)

def DirectSerializationTraitsUlongLong_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsUlongLong_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsUlongLong_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsUlongLong_deserialize(*args):
  """DirectSerializationTraitsUlongLong_deserialize(long bytes, char charBuffer, long count, unsigned long long buffer)"""
  return _Teuchos.DirectSerializationTraitsUlongLong_deserialize(*args)

class SerializationTraitsUlongLong(_object):
    """Proxy of C++ Teuchos::SerializationTraits<(long,unsigned long long)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsUlongLong, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsUlongLong, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.SerializationTraitsUlongLong_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.SerializationTraitsUlongLong_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(unsigned long long ptr) -> char"""
        return _Teuchos.SerializationTraitsUlongLong_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long bytes) -> long"""
        return _Teuchos.SerializationTraitsUlongLong_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> unsigned long long"""
        return _Teuchos.SerializationTraitsUlongLong_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.SerializationTraitsUlongLong_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """
        serialize(long count, unsigned long long buffer, long bytes, 
            char charBuffer)
        """
        return _Teuchos.SerializationTraitsUlongLong_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.SerializationTraitsUlongLong_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, unsigned long long buffer)"""
        return _Teuchos.SerializationTraitsUlongLong_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsUlongLong"""
        this = _Teuchos.new_SerializationTraitsUlongLong(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsUlongLong
    __del__ = lambda self : None;
SerializationTraitsUlongLong_swigregister = _Teuchos.SerializationTraitsUlongLong_swigregister
SerializationTraitsUlongLong_swigregister(SerializationTraitsUlongLong)

def SerializationTraitsUlongLong_fromCountToDirectBytes(*args):
  """SerializationTraitsUlongLong_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.SerializationTraitsUlongLong_fromCountToDirectBytes(*args)

def SerializationTraitsUlongLong_convertToCharPtr(*args):
  """SerializationTraitsUlongLong_convertToCharPtr(unsigned long long ptr) -> char"""
  return _Teuchos.SerializationTraitsUlongLong_convertToCharPtr(*args)

def SerializationTraitsUlongLong_fromDirectBytesToCount(*args):
  """SerializationTraitsUlongLong_fromDirectBytesToCount(long bytes) -> long"""
  return _Teuchos.SerializationTraitsUlongLong_fromDirectBytesToCount(*args)

def SerializationTraitsUlongLong_convertFromCharPtr(*args):
  """SerializationTraitsUlongLong_convertFromCharPtr(char ptr) -> unsigned long long"""
  return _Teuchos.SerializationTraitsUlongLong_convertFromCharPtr(*args)

def SerializationTraitsUlongLong_fromCountToIndirectBytes(*args):
  """SerializationTraitsUlongLong_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.SerializationTraitsUlongLong_fromCountToIndirectBytes(*args)

def SerializationTraitsUlongLong_serialize(*args):
  """
    SerializationTraitsUlongLong_serialize(long count, unsigned long long buffer, long bytes, 
        char charBuffer)
    """
  return _Teuchos.SerializationTraitsUlongLong_serialize(*args)

def SerializationTraitsUlongLong_fromIndirectBytesToCount(*args):
  """SerializationTraitsUlongLong_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.SerializationTraitsUlongLong_fromIndirectBytesToCount(*args)

def SerializationTraitsUlongLong_deserialize(*args):
  """SerializationTraitsUlongLong_deserialize(long bytes, char charBuffer, long count, unsigned long long buffer)"""
  return _Teuchos.SerializationTraitsUlongLong_deserialize(*args)

class DirectSerializationTraitsFloat(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,float)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsFloat, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsFloat, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsFloat_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsFloat_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(float ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsFloat_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsFloat_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> float"""
        return _Teuchos.DirectSerializationTraitsFloat_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsFloat_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, float buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsFloat_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsFloat_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, float buffer)"""
        return _Teuchos.DirectSerializationTraitsFloat_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsFloat"""
        this = _Teuchos.new_DirectSerializationTraitsFloat(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsFloat
    __del__ = lambda self : None;
DirectSerializationTraitsFloat_swigregister = _Teuchos.DirectSerializationTraitsFloat_swigregister
DirectSerializationTraitsFloat_swigregister(DirectSerializationTraitsFloat)

def DirectSerializationTraitsFloat_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsFloat_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsFloat_fromCountToDirectBytes(*args)

def DirectSerializationTraitsFloat_convertToCharPtr(*args):
  """DirectSerializationTraitsFloat_convertToCharPtr(float ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsFloat_convertToCharPtr(*args)

def DirectSerializationTraitsFloat_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsFloat_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsFloat_fromDirectBytesToCount(*args)

def DirectSerializationTraitsFloat_convertFromCharPtr(*args):
  """DirectSerializationTraitsFloat_convertFromCharPtr(char ptr) -> float"""
  return _Teuchos.DirectSerializationTraitsFloat_convertFromCharPtr(*args)

def DirectSerializationTraitsFloat_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsFloat_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsFloat_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsFloat_serialize(*args):
  """DirectSerializationTraitsFloat_serialize(long count, float buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsFloat_serialize(*args)

def DirectSerializationTraitsFloat_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsFloat_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsFloat_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsFloat_deserialize(*args):
  """DirectSerializationTraitsFloat_deserialize(long bytes, char charBuffer, long count, float buffer)"""
  return _Teuchos.DirectSerializationTraitsFloat_deserialize(*args)

class SerializationTraitsFloat(DirectSerializationTraitsFloat):
    """Proxy of C++ Teuchos::SerializationTraits<(long,float)> class"""
    __swig_setmethods__ = {}
    for _s in [DirectSerializationTraitsFloat]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsFloat, name, value)
    __swig_getmethods__ = {}
    for _s in [DirectSerializationTraitsFloat]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsFloat, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsFloat"""
        this = _Teuchos.new_SerializationTraitsFloat(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsFloat
    __del__ = lambda self : None;
SerializationTraitsFloat_swigregister = _Teuchos.SerializationTraitsFloat_swigregister
SerializationTraitsFloat_swigregister(SerializationTraitsFloat)

class DirectSerializationTraitsDouble(_object):
    """Proxy of C++ Teuchos::DirectSerializationTraits<(long,double)> class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DirectSerializationTraitsDouble, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DirectSerializationTraitsDouble, name)
    __repr__ = _swig_repr
    supportsDirectSerialization = _Teuchos.DirectSerializationTraitsDouble_supportsDirectSerialization
    def fromCountToDirectBytes(*args):
        """fromCountToDirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsDouble_fromCountToDirectBytes(*args)

    if _newclass:fromCountToDirectBytes = staticmethod(fromCountToDirectBytes)
    __swig_getmethods__["fromCountToDirectBytes"] = lambda x: fromCountToDirectBytes
    def convertToCharPtr(*args):
        """convertToCharPtr(double ptr) -> char"""
        return _Teuchos.DirectSerializationTraitsDouble_convertToCharPtr(*args)

    if _newclass:convertToCharPtr = staticmethod(convertToCharPtr)
    __swig_getmethods__["convertToCharPtr"] = lambda x: convertToCharPtr
    def fromDirectBytesToCount(*args):
        """fromDirectBytesToCount(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsDouble_fromDirectBytesToCount(*args)

    if _newclass:fromDirectBytesToCount = staticmethod(fromDirectBytesToCount)
    __swig_getmethods__["fromDirectBytesToCount"] = lambda x: fromDirectBytesToCount
    def convertFromCharPtr(*args):
        """convertFromCharPtr(char ptr) -> double"""
        return _Teuchos.DirectSerializationTraitsDouble_convertFromCharPtr(*args)

    if _newclass:convertFromCharPtr = staticmethod(convertFromCharPtr)
    __swig_getmethods__["convertFromCharPtr"] = lambda x: convertFromCharPtr
    def fromCountToIndirectBytes(*args):
        """fromCountToIndirectBytes(long count) -> long"""
        return _Teuchos.DirectSerializationTraitsDouble_fromCountToIndirectBytes(*args)

    if _newclass:fromCountToIndirectBytes = staticmethod(fromCountToIndirectBytes)
    __swig_getmethods__["fromCountToIndirectBytes"] = lambda x: fromCountToIndirectBytes
    def serialize(*args):
        """serialize(long count, double buffer, long bytes, char charBuffer)"""
        return _Teuchos.DirectSerializationTraitsDouble_serialize(*args)

    if _newclass:serialize = staticmethod(serialize)
    __swig_getmethods__["serialize"] = lambda x: serialize
    def fromIndirectBytesToCount(*args):
        """fromIndirectBytesToCount(long bytes) -> long"""
        return _Teuchos.DirectSerializationTraitsDouble_fromIndirectBytesToCount(*args)

    if _newclass:fromIndirectBytesToCount = staticmethod(fromIndirectBytesToCount)
    __swig_getmethods__["fromIndirectBytesToCount"] = lambda x: fromIndirectBytesToCount
    def deserialize(*args):
        """deserialize(long bytes, char charBuffer, long count, double buffer)"""
        return _Teuchos.DirectSerializationTraitsDouble_deserialize(*args)

    if _newclass:deserialize = staticmethod(deserialize)
    __swig_getmethods__["deserialize"] = lambda x: deserialize
    def __init__(self, *args): 
        """__init__(self) -> DirectSerializationTraitsDouble"""
        this = _Teuchos.new_DirectSerializationTraitsDouble(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DirectSerializationTraitsDouble
    __del__ = lambda self : None;
DirectSerializationTraitsDouble_swigregister = _Teuchos.DirectSerializationTraitsDouble_swigregister
DirectSerializationTraitsDouble_swigregister(DirectSerializationTraitsDouble)

def DirectSerializationTraitsDouble_fromCountToDirectBytes(*args):
  """DirectSerializationTraitsDouble_fromCountToDirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsDouble_fromCountToDirectBytes(*args)

def DirectSerializationTraitsDouble_convertToCharPtr(*args):
  """DirectSerializationTraitsDouble_convertToCharPtr(double ptr) -> char"""
  return _Teuchos.DirectSerializationTraitsDouble_convertToCharPtr(*args)

def DirectSerializationTraitsDouble_fromDirectBytesToCount(*args):
  """DirectSerializationTraitsDouble_fromDirectBytesToCount(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsDouble_fromDirectBytesToCount(*args)

def DirectSerializationTraitsDouble_convertFromCharPtr(*args):
  """DirectSerializationTraitsDouble_convertFromCharPtr(char ptr) -> double"""
  return _Teuchos.DirectSerializationTraitsDouble_convertFromCharPtr(*args)

def DirectSerializationTraitsDouble_fromCountToIndirectBytes(*args):
  """DirectSerializationTraitsDouble_fromCountToIndirectBytes(long count) -> long"""
  return _Teuchos.DirectSerializationTraitsDouble_fromCountToIndirectBytes(*args)

def DirectSerializationTraitsDouble_serialize(*args):
  """DirectSerializationTraitsDouble_serialize(long count, double buffer, long bytes, char charBuffer)"""
  return _Teuchos.DirectSerializationTraitsDouble_serialize(*args)

def DirectSerializationTraitsDouble_fromIndirectBytesToCount(*args):
  """DirectSerializationTraitsDouble_fromIndirectBytesToCount(long bytes) -> long"""
  return _Teuchos.DirectSerializationTraitsDouble_fromIndirectBytesToCount(*args)

def DirectSerializationTraitsDouble_deserialize(*args):
  """DirectSerializationTraitsDouble_deserialize(long bytes, char charBuffer, long count, double buffer)"""
  return _Teuchos.DirectSerializationTraitsDouble_deserialize(*args)

class SerializationTraitsDouble(DirectSerializationTraitsDouble):
    """Proxy of C++ Teuchos::SerializationTraits<(long,double)> class"""
    __swig_setmethods__ = {}
    for _s in [DirectSerializationTraitsDouble]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerializationTraitsDouble, name, value)
    __swig_getmethods__ = {}
    for _s in [DirectSerializationTraitsDouble]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerializationTraitsDouble, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerializationTraitsDouble"""
        this = _Teuchos.new_SerializationTraitsDouble(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_SerializationTraitsDouble
    __del__ = lambda self : None;
SerializationTraitsDouble_swigregister = _Teuchos.SerializationTraitsDouble_swigregister
SerializationTraitsDouble_swigregister(SerializationTraitsDouble)

def DirectSerializationTraits(scalarType):
    """
    DirectSerializationTraits(str scalarType) -> DirectSerializationTraits<...>

    The scalarType argument is for specifying the type of scalar for
    which direct serialization is requested.  Limited NumPy-style type
    specification is supported:

        'b'  byte
        'B'  unsigned byte
        'h'  short
        'H'  unsigned short
        'i'  int
        'I'  unsigned int
        'l'  long
        'L'  unsigned long
        'q'  long long
        'Q'  unsigned long long
        'f'  float
        'd'  double
    """
    if   scalarType == 'b': return DirectSerializationTraitsByte()
    elif scalarType == 'B': return DirectSerializationTraitsUbyte()
    elif scalarType == 'h': return DirectSerializationTraitsShort()
    elif scalarType == 'H': return DirectSerializationTraitsUshort()
    elif scalarType == 'i': return DirectSerializationTraitsInt()
    elif scalarType == 'I': return DirectSerializationTraitsUint()
    elif scalarType == 'l': return DirectSerializationTraitsLong()
    elif scalarType == 'L': return DirectSerializationTraitsUlong()
    elif scalarType == 'q': return DirectSerializationTraitsLongLong()
    elif scalarType == 'Q': return DirectSerializationTraitsUlongLong()
    elif scalarType == 'f': return DirectSerializationTraitsFloat()
    elif scalarType == 'd': return DirectSerializationTraitsDouble()
    raise NotImplementedError, "DirectSerializationTraits for " + repr(scalarType) + \
	  " not supported"

def SerializationTraits(scalarType):
    """
    SerializationTraits(str scalarType) -> SerializationTraits<...>

    The scalarType argument is for specifying the type of scalar for
    which serialization is requested.  Limited NumPy-style type
    specification is supported:

        'b'  byte
        'B'  unsigned byte
        'h'  short
        'H'  unsigned short
        'i'  int
        'I'  unsigned int
        'l'  long
        'L'  unsigned long
        'q'  long long
        'Q'  unsigned long long
        'f'  float
        'd'  double
    """
    if   scalarType == 'b': return SerializationTraitsByte()
    elif scalarType == 'B': return SerializationTraitsUbyte()
    elif scalarType == 'h': return SerializationTraitsShort()
    elif scalarType == 'H': return SerializationTraitsUshort()
    elif scalarType == 'i': return SerializationTraitsInt()
    elif scalarType == 'I': return SerializationTraitsUint()
    elif scalarType == 'l': return SerializationTraitsLong()
    elif scalarType == 'L': return SerializationTraitsUlong()
    elif scalarType == 'q': return SerializationTraitsLongLong()
    elif scalarType == 'Q': return SerializationTraitsUlongLong()
    elif scalarType == 'f': return SerializationTraitsFloat()
    elif scalarType == 'd': return SerializationTraitsDouble()
    raise NotImplementedError, "SerializationTraits for " + repr(scalarType) + \
	  " not supported"


def Init_Argv(*args):
  """Init_Argv(PyObject args) -> PyObject"""
  return _Teuchos.Init_Argv(*args)

def Finalize(*args):
  """Finalize() -> PyObject"""
  return _Teuchos.Finalize(*args)
VERB_DEFAULT = _Teuchos.VERB_DEFAULT
VERB_NONE = _Teuchos.VERB_NONE
VERB_LOW = _Teuchos.VERB_LOW
VERB_MEDIUM = _Teuchos.VERB_MEDIUM
VERB_HIGH = _Teuchos.VERB_HIGH
VERB_EXTREME = _Teuchos.VERB_EXTREME

def verbosityLevelToString(*args):
  """verbosityLevelToString(EVerbosityLevel verbLevel) -> string"""
  return _Teuchos.verbosityLevelToString(*args)

def includesVerbLevel(*args):
  """
    includesVerbLevel(EVerbosityLevel verbLevel, EVerbosityLevel requestedVerbLevel, 
        bool isDefaultLevel = False) -> bool
    """
  return _Teuchos.includesVerbLevel(*args)

def incrVerbLevel(*args):
  """incrVerbLevel(EVerbosityLevel inputVerbLevel, int numLevels) -> EVerbosityLevel"""
  return _Teuchos.incrVerbLevel(*args)

def fancyOStream(*args):
  """
    fancyOStream(Teuchos::RCP<(std::basic_ostream<(char)>)> oStream, 
        std::basic_string<(char)> tabIndentStr = " ", 
        int startingTab = 0, bool showLinePrefix = False, 
        int maxLenLinePrefix = 10, bool showTabCount = False, 
        bool showProcRank = False) -> Teuchos::RCP<(Teuchos::basic_FancyOStream<(char,std::char_traits<(char)>)>)>
    """
  return _Teuchos.fancyOStream(*args)

def getFancyOStream(*args):
  """getFancyOStream(Teuchos::RCP<(std::basic_ostream<(char)>)> out) -> Teuchos::RCP<(Teuchos::basic_FancyOStream<(char,std::char_traits<(char)>)>)>"""
  return _Teuchos.getFancyOStream(*args)
class LabeledObject(_object):
    """Proxy of C++ Teuchos::LabeledObject class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LabeledObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LabeledObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> LabeledObject"""
        if self.__class__ == LabeledObject:
            _self = None
        else:
            _self = self
        this = _Teuchos.new_LabeledObject(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_LabeledObject
    __del__ = lambda self : None;
    def setObjectLabel(self, *args):
        """setObjectLabel(self, string objectLabel)"""
        return _Teuchos.LabeledObject_setObjectLabel(self, *args)

    def getObjectLabel(self, *args):
        """getObjectLabel(self) -> string"""
        return _Teuchos.LabeledObject_getObjectLabel(self, *args)

    def __disown__(self):
        self.this.disown()
        _Teuchos.disown_LabeledObject(self)
        return weakref_proxy(self)
LabeledObject_swigregister = _Teuchos.LabeledObject_swigregister
LabeledObject_swigregister(LabeledObject)

class Describable(LabeledObject):
    """Proxy of C++ Teuchos::Describable class"""
    __swig_setmethods__ = {}
    for _s in [LabeledObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Describable, name, value)
    __swig_getmethods__ = {}
    for _s in [LabeledObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Describable, name)
    __repr__ = _swig_repr
    def description(self, *args):
        """description(self) -> string"""
        return _Teuchos.Describable_description(self, *args)

    def describe(self, *args):
        """describe(self, FancyOStream out, EVerbosityLevel verbLevel = verbLevel_default)"""
        return _Teuchos.Describable_describe(self, *args)

    def __init__(self, *args): 
        """__init__(self) -> Describable"""
        if self.__class__ == Describable:
            _self = None
        else:
            _self = self
        this = _Teuchos.new_Describable(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_Describable
    __del__ = lambda self : None;
    def __disown__(self):
        self.this.disown()
        _Teuchos.disown_Describable(self)
        return weakref_proxy(self)
Describable_swigregister = _Teuchos.Describable_swigregister
Describable_swigregister(Describable)
Describable.verbLevel_default = _Teuchos.cvar.Describable_verbLevel_default

class DescribableStreamManipulatorState(_object):
    """Proxy of C++ Teuchos::DescribableStreamManipulatorState class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, DescribableStreamManipulatorState, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, DescribableStreamManipulatorState, name)
    __repr__ = _swig_repr
    __swig_getmethods__["describable"] = _Teuchos.DescribableStreamManipulatorState_describable_get
    if _newclass:describable = _swig_property(_Teuchos.DescribableStreamManipulatorState_describable_get)
    __swig_getmethods__["verbLevel"] = _Teuchos.DescribableStreamManipulatorState_verbLevel_get
    if _newclass:verbLevel = _swig_property(_Teuchos.DescribableStreamManipulatorState_verbLevel_get)
    def __init__(self, *args): 
        """__init__(self, Describable _describable, EVerbosityLevel _verbLevel = VERB_MEDIUM) -> DescribableStreamManipulatorState"""
        this = _Teuchos.new_DescribableStreamManipulatorState(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_DescribableStreamManipulatorState
    __del__ = lambda self : None;
DescribableStreamManipulatorState_swigregister = _Teuchos.DescribableStreamManipulatorState_swigregister
DescribableStreamManipulatorState_swigregister(DescribableStreamManipulatorState)


def describe(*args):
  """describe(Describable describable, EVerbosityLevel verbLevel = verbLevel_default) -> DescribableStreamManipulatorState"""
  return _Teuchos.describe(*args)
class CommRequest(Describable):
    """Proxy of C++ Teuchos::CommRequest class"""
    __swig_setmethods__ = {}
    for _s in [Describable]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CommRequest, name, value)
    __swig_getmethods__ = {}
    for _s in [Describable]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CommRequest, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> CommRequest"""
        this = _Teuchos.new_CommRequest(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_CommRequest
    __del__ = lambda self : None;
CommRequest_swigregister = _Teuchos.CommRequest_swigregister
CommRequest_swigregister(CommRequest)

class Comm_long(Describable):
    """Proxy of C++ Teuchos::Comm<(long)> class"""
    __swig_setmethods__ = {}
    for _s in [Describable]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Comm_long, name, value)
    __swig_getmethods__ = {}
    for _s in [Describable]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Comm_long, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def getRank(self, *args):
        """getRank(self) -> int"""
        return _Teuchos.Comm_long_getRank(self, *args)

    def getSize(self, *args):
        """getSize(self) -> int"""
        return _Teuchos.Comm_long_getSize(self, *args)

    def barrier(self, *args):
        """barrier(self)"""
        return _Teuchos.Comm_long_barrier(self, *args)

    def reduceAllAndScatter(self, *args):
        """
        reduceAllAndScatter(self, Teuchos::ValueTypeReductionOp<(long,char)> reductOp, 
            long sendBytes, char sendBuffer, long recvCounts, 
            char myGlobalReducts)
        """
        return _Teuchos.Comm_long_reduceAllAndScatter(self, *args)

    def send(self, *args):
        """send(self, long bytes, char sendBuffer, int destRank)"""
        return _Teuchos.Comm_long_send(self, *args)

    def receive(self, *args):
        """receive(self, int sourceRank, long bytes, char recvBuffer) -> int"""
        return _Teuchos.Comm_long_receive(self, *args)

    def broadcast(self, *args):
        """
        broadcast(self, int rootRank, numpy.ndarray buffer)

        Broadcast the contents of buffer from processor rootRank to all of the
        other processors.  Argument buffer must be a numpy array, so that the
        broadcast can be performed in-place.  Its scalar data type can be any
        numerical type supported by numpy.
        """
        return _Teuchos.Comm_long_broadcast(self, *args)

    def gatherAll(self, *args):
        """
        gatherAll(self, buffer) -> numpy.ndarray

        Gather the contents of buffer to all of the processors.  Argument
        buffer can be a numpy array or any sequence that can be converted to a
        numpy array.  Its scalar data type can be any numerical type supported
        by numpy.  The return argument is a numpy array of the same type.
        """
        return _Teuchos.Comm_long_gatherAll(self, *args)

    def reduceAll(self, *args):
        """
        scan(EReductionType reductOp, buffer) -> numpy.ndarray

        Return the scan of the contents of buffer according to the operation
        designated by reductOp on each of the processors.  Argument reductOp
        can be Teuchos.REDUCE_SUM, Teuchos.REDUCE_MAX, or Teuchos.REDUCE_MIN.
        Argument buffer can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type can be any numerical
        type supported by numpy.  The return argument is a numpy array of the
        same type.
        """
        return _Teuchos.Comm_long_reduceAll(self, *args)

    def scan(self, *args):
        """scan(self, EReductionType reductOp, PyObject sendObj) -> PyObject"""
        return _Teuchos.Comm_long_scan(self, *args)

    def __str__(self, *args):
        """__str__(self) -> string"""
        return _Teuchos.Comm_long___str__(self, *args)

    __swig_destroy__ = _Teuchos.delete_Comm_long
    __del__ = lambda self : None;
Comm_long_swigregister = _Teuchos.Comm_long_swigregister
Comm_long_swigregister(Comm_long)

Comm = Comm_long

class SerialComm_long(Comm_long):
    """Proxy of C++ Teuchos::SerialComm<(long)> class"""
    __swig_setmethods__ = {}
    for _s in [Comm_long]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, SerialComm_long, name, value)
    __swig_getmethods__ = {}
    for _s in [Comm_long]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, SerialComm_long, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> SerialComm_long"""
        this = _Teuchos.new_SerialComm_long(*args)
        try: self.this.append(this)
        except: self.this = this
    def getRank(self, *args):
        """getRank(self) -> int"""
        return _Teuchos.SerialComm_long_getRank(self, *args)

    def getSize(self, *args):
        """getSize(self) -> int"""
        return _Teuchos.SerialComm_long_getSize(self, *args)

    def barrier(self, *args):
        """barrier(self)"""
        return _Teuchos.SerialComm_long_barrier(self, *args)

    def reduceAllAndScatter(self, *args):
        """
        reduceAllAndScatter(self, Teuchos::ValueTypeReductionOp<(long,char)> reductOp, 
            long sendBytes, char sendBuffer, long recvCounts, 
            char myGlobalReducts)
        """
        return _Teuchos.SerialComm_long_reduceAllAndScatter(self, *args)

    def send(self, *args):
        """send(self, long bytes, char sendBuffer, int destRank)"""
        return _Teuchos.SerialComm_long_send(self, *args)

    def receive(self, *args):
        """receive(self, int sourceRank, long bytes, char recvBuffer) -> int"""
        return _Teuchos.SerialComm_long_receive(self, *args)

    def description(self, *args):
        """description(self) -> string"""
        return _Teuchos.SerialComm_long_description(self, *args)

    __swig_destroy__ = _Teuchos.delete_SerialComm_long
    __del__ = lambda self : None;
SerialComm_long_swigregister = _Teuchos.SerialComm_long_swigregister
SerialComm_long_swigregister(SerialComm_long)

SerialComm = SerialComm_long

REDUCE_SUM = _Teuchos.REDUCE_SUM
REDUCE_MIN = _Teuchos.REDUCE_MIN
REDUCE_MAX = _Teuchos.REDUCE_MAX
REDUCE_AND = _Teuchos.REDUCE_AND

def rank_long(*args):
  """rank_long(Comm_long comm) -> int"""
  return _Teuchos.rank_long(*args)

def size_long(*args):
  """size_long(Comm_long comm) -> int"""
  return _Teuchos.size_long(*args)

def barrier_long(*args):
  """barrier_long(Comm_long comm)"""
  return _Teuchos.barrier_long(*args)
rank    = rank_long
size    = size_long
barrier = barrier_long

def broadcast(comm, rootRank, buffer):
  """
  broadcast(Comm comm, int rootRank, numpy.ndarray buffer)

  Broadcast the contents of buffer from processor rootRank to all of
  the other processors.  Argument buffer must be a numpy array, so
  that the broadcast can be performed in-place.  Its scalar data type
  can be any numerical type supported by numpy.
  """
  comm.broadcast(rootRank, buffer)

def gatherAll(comm, buffer):
  """
  gatherAll(Comm comm, buffer) -> numpy.ndarray

  Gather the contents of buffer to all of the processors.  Argument
  buffer can be a numpy array or any sequence that can be converted to
  a numpy array.  Its scalar data type can be any numerical type
  supported by numpy.  The return argument is a numpy array of the
  same type.
  """
  return comm.gatherAll(buffer)

def reduceAll(comm, reductOp, buffer):
  """
  reduceAll(Comm comm, EReductionType reductOp, buffer) -> numpy.ndarray

  Reduce the contents of buffer according to the operation designated
  by reductOp on all of the processors.  Argument reductOp can be
  Teuchos.REDUCE_SUM, Teuchos.REDUCE_MAX, or Teuchos.REDUCE_MIN.
  Argument buffer can be a numpy array or any sequence that can be
  converted to a numpy array.  Its scalar data type can be any
  numerical type supported by numpy.  The return argument is a numpy
  array of the same type.
  """
  return comm.reduceAll(reductOp, buffer)

def scan(comm, reductOp, buffer):
  """
  scan(Comm comm, EReductionType reductOp, buffer) -> numpy.ndarray

  Return the scan of the contents of buffer according to the operation
  designated by reductOp on each of the processors.  Argument reductOp
  can be Teuchos.REDUCE_SUM, Teuchos.REDUCE_MAX, or
  Teuchos.REDUCE_MIN.  Argument buffer can be a numpy array or any
  sequence that can be converted to a numpy array.  Its scalar data
  type can be any numerical type supported by numpy.  The return
  argument is a numpy array of the same type.
  """
  return comm.scan(reductOp, buffer)

# Call MPI_Init if appropriate
import sys
Init_Argv(sys.argv)
del sys

# Arrange for MPI_Finalize to be called at exit, if appropriate
import atexit
atexit.register(Finalize)

class DefaultComm:
    "Encapsulate the default global communicator"
    __defaultComm = SerialComm()
    @classmethod
    def getComm(cls):
        "Return the default global communicator"
        return cls.__defaultComm

VALIDATE_USED_ENABLED = _Teuchos.VALIDATE_USED_ENABLED
VALIDATE_USED_DISABLED = _Teuchos.VALIDATE_USED_DISABLED
VALIDATE_DEFAULTS_ENABLED = _Teuchos.VALIDATE_DEFAULTS_ENABLED
VALIDATE_DEFAULTS_DISABLED = _Teuchos.VALIDATE_DEFAULTS_DISABLED
class ParameterList(_object):
    """
    The ``ParameterList`` class is an important utility class that is used
    by several Trilinos packages for communicating arbitrary-type
    parameters between users and packages.

    Often, the ``ParameterList`` class is invisible to the user.  It is
    analagous to the python dictionary (with the restriction that the
    dictionary keys must be strings), and python programmers can provide a
    python dictionary wherever a ``ParameterList`` is expected.
    ``Teuchos`` is imported by other packages that use the
    ``ParameterList`` class and converts between dictionaries and
    ``ParameterList`` objects automatically.

    The user can create a ``Teuchos.ParameterList`` directly, using the
    constructor, ``set`` and ``sublist`` methods, if he so chooses, and
    methods that accept ``ParameterList`` objects will work as expected.
    It is really just a question of verbosity and elegance that argues in
    favor of using a python dictionary.

    The python implementation of the ``ParameterList`` class has been
    expanded extensively.  Its constructor can accept a python dictionary,
    and several methods and operators have been added to the class so that
    it behaves somewhat like a dictionary.

    C++ ``ParameterList`` objects are designed to support parameters of
    arbitrary type.  The python implementation supports a subset of types
    *a priori* :

      +-------------------------+-----+-------------------+
      |       Python type       | Dir |     C/C++ type    |
      +-------------------------+-----+-------------------+
      | ``bool``                | <-> | ``bool``          |
      +-------------------------+-----+-------------------+
      | ``int``                 | <-> | ``int``           |
      +-------------------------+-----+-------------------+
      | ``float``               | <-> | ``double``        |
      +-------------------------+-----+-------------------+
      | ``str``                 | <-- | ``char *``        |
      +-------------------------+-----+-------------------+
      | ``str``                 | <-> | ``std::string``   |
      +-------------------------+-----+-------------------+
      | ``dict``                | --> | ``ParameterList`` |
      +-------------------------+-----+-------------------+
      | ``ParameterList``       | <-> | ``ParameterList`` |
      +-------------------------+-----+-------------------+

    The C++ ``ParameterList`` class supports ``begin()`` and ``end()``
    methods for iterating over the parameters.  These methods are disabled
    in the python implementation, in favor of the dictionary iterator
    methods: ``__iter__()``, ``iteritems()``, ``iterkeys()`` and
    ``itervalues()``.

    Note that the C++ implementation of the ``ParameterList`` class does
    not support parameter deletion.  Therefore, python dictionary methods
    that delete items, such as ``pop()`` or ``__delitem__()``, have not
    been added to the ``ParameterList`` class.
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParameterList, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ParameterList, name)
    __swig_destroy__ = _Teuchos.delete_ParameterList
    __del__ = lambda self : None;
    def setName(self, *args):
        """
        setName(self, string name) -> ParameterList

        ParameterList
        & Teuchos::ParameterList::setName(const std::string &name)

        Set the name of *this list. 
        """
        return _Teuchos.ParameterList_setName(self, *args)

    def setParametersNotAlreadySet(self, *args):
        """
        setParametersNotAlreadySet(self, ParameterList source) -> ParameterList

        ParameterList &
        Teuchos::ParameterList::setParametersNotAlreadySet(const ParameterList
        &source)

        Set the parameters in source that are not already set in *this.

        Note, this function will set the parameters and sublists from source
        into *this but will not result in parameters being removed from *this
        or in parameters already set in *this being overrided. Parameters in
        *this with the same names as those in source will not be overwritten.

        """
        return _Teuchos.ParameterList_setParametersNotAlreadySet(self, *args)

    def disableRecursiveValidation(self, *args):
        """
        disableRecursiveValidation(self) -> ParameterList

        ParameterList &
        Teuchos::ParameterList::disableRecursiveValidation()

        Disallow recusive validation when this sublist is used in a valid
        parameter list.

        This function should be called when setting a sublist in a valid
        parameter list which is broken off to be passed to another object. The
        other object should validate its own list. 
        """
        return _Teuchos.ParameterList_disableRecursiveValidation(self, *args)

    def getEntry(self, *args):
        """
        getEntry(self, string name) -> ParameterEntry
        getEntry(self, string name) -> ParameterEntry

        const
        ParameterEntry & Teuchos::ParameterList::getEntry(const std::string
        &name) const

        Retrieves a const entry with the name name.

        Throws  Exceptions::InvalidParameterName if this parameter does not
        exist. 
        """
        return _Teuchos.ParameterList_getEntry(self, *args)

    def remove(self, *args):
        """
        remove(self, string name, bool throwIfNotExists = True) -> bool

        bool
        Teuchos::ParameterList::remove(std::string const &name, bool
        throwIfNotExists=true)

        Remove a parameter (does not depend on the type of the parameter).

        Parameters:
        -----------

        name:  [in] The name of the parameter to remove

        throwIfNotExists:  [in] If true then if the parameter with the name
        name does not exist then a std::exception will be thrown!

        Returns true if the parameter was removed, and false if the parameter
        was not removed ( false return value possible only if
        throwIfExists==false). 
        """
        return _Teuchos.ParameterList_remove(self, *args)

    def sublist(self, *args):
        """
        sublist(self, string name, bool mustAlreadyExist = False, string docString = "") -> ParameterList

        const
        ParameterList & Teuchos::ParameterList::sublist(const std::string
        &name) const

        Return a const reference to an existing sublist name. If the list does
        not already exist or the name exists but is not a sublist, an
        std::exception is thrown. 
        """
        return _Teuchos.ParameterList_sublist(self, *args)

    def name(self, *args):
        """
        name(self) -> string

        const
        std::string & Teuchos::ParameterList::name(ConstIterator i) const

        Access to name (i.e., returns i->first). 
        """
        return _Teuchos.ParameterList_name(self, *args)

    def isParameter(self, *args):
        """
        isParameter(self, string name) -> bool

        bool
        Teuchos::ParameterList::isParameter(const std::string &name) const

        Query the existence of a parameter.

        "true" if a parameter with this name exists, else "false".
        Warning, this function should almost never be used! Instead, consider
        using getEntryPtr() instead. 
        """
        return _Teuchos.ParameterList_isParameter(self, *args)

    def isSublist(self, *args):
        """
        isSublist(self, string name) -> bool

        bool
        Teuchos::ParameterList::isSublist(const std::string &name) const

        Query the existence of a parameter and whether it is a parameter list.

        "true" if a parameter with this name exists and is itself a
        parameter list, else "false". Warning, this function should almost
        never be used! Instead, consider using getEntryPtr() instead. 
        """
        return _Teuchos.ParameterList_isSublist(self, *args)

    def currentParametersString(self, *args):
        """
        currentParametersString(self) -> string

        std::string Teuchos::ParameterList::currentParametersString() const

        Create a single formated std::string of all of the zero-level
        parameters in this list. 
        """
        return _Teuchos.ParameterList_currentParametersString(self, *args)

    def validateParameters(self, *args):
        """
        validateParameters(self, ParameterList validParamList, int depth = 1000, EValidateUsed validateUsed = VALIDATE_USED_ENABLED, 
            EValidateDefaults validateDefaults = VALIDATE_DEFAULTS_ENABLED)

        void Teuchos::ParameterList::validateParameters(ParameterList const
        &validParamList, int const depth=1000, EValidateUsed const
        validateUsed=VALIDATE_USED_ENABLED, EValidateDefaults const
        validateDefaults=VALIDATE_DEFAULTS_ENABLED) const

        Validate the parameters in this list given valid selections in the
        input list.

        Parameters:
        -----------

        validParamList:  [in] This is the list that the parameters and sublist
        in *this are compared against.

        depth:  [in] Determines the number of levels of depth that the
        validation will recurse into. A value of dpeth=0 means that only the
        top level parameters and sublists will be checked. Default: depth =
        large number.

        validateUsed:  [in] Determines if parameters that have been used are
        checked against those in validParamList. Default: validateDefaults =
        VALIDATE_DEFAULTS_ENABLED.

        validateDefaults:  [in] Determines if parameters set at their default
        values using get(name,defaultVal) are checked against those in
        validParamList. Default: validateDefaults = VALIDATE_DEFAULTS_ENABLED.

        If a parameter in *this is not found in validParamList then an
        std::exception of type  Exceptions::InvalidParameterName will be
        thrown which will contain an excellent error message returned by
        excpt.what(). If the parameter exists but has the wrong type, then an
        std::exception type  Exceptions::InvalidParameterType will be thrown.
        If the parameter exists and has the right type, but the value is not
        valid then an std::exception type  Exceptions::InvalidParameterValue
        will be thrown.

        Recursive validation stops when: The maxinum depth is reached

        A sublist note in validParamList has been marked with the
        disableRecursiveValidation() function, or

        There are not more parameters or sublists left in *this

        A breath-first search is performed to validate all of the parameters
        in one sublist before moving into nested subslist. 
        """
        return _Teuchos.ParameterList_validateParameters(self, *args)

    def validateParametersAndSetDefaults(self, *args):
        """
        validateParametersAndSetDefaults(self, ParameterList validParamList, int depth = 1000)

        void
        Teuchos::ParameterList::validateParametersAndSetDefaults(ParameterList
        const &validParamList, int const depth=1000)

        Validate the parameters in this list given valid selections in the
        input list and set defaults for those not set.

        Parameters:
        -----------

        validParamList:  [in] This is the list that the parameters and sublist
        in *this are compared against.

        depth:  [in] Determines the number of levels of depth that the
        validation will recurse into. A value of dpeth=0 means that only the
        top level parameters and sublists will be checked. Default: depth =
        large number.

        If a parameter in *this is not found in validParamList then an
        std::exception of type  Exceptions::InvalidParameterName will be
        thrown which will contain an excellent error message returned by
        excpt.what(). If the parameter exists but has the wrong type, then an
        std::exception type  Exceptions::InvalidParameterType will be thrown.
        If the parameter exists and has the right type, but the value is not
        valid then an std::exception type  Exceptions::InvalidParameterValue
        will be thrown. If a parameter in validParamList does not exist in
        *this, then it will be set at its default value as determined by
        validParamList.

        Recursive validation stops when: The maxinum depth is reached

        A sublist note in validParamList has been marked with the
        disableRecursiveValidation() function, or

        There are not more parameters or sublists left in *this

        A breath-first search is performed to validate all of the parameters
        in one sublist before moving into nested subslist. 
        """
        return _Teuchos.ParameterList_validateParametersAndSetDefaults(self, *args)

    def __init__(self, *args): 
        """
        __init__(self) -> ParameterList
        __init__(self, string name) -> ParameterList
        __init__(self, ParameterList source) -> ParameterList
        __init__(self, PyObject dict, string name = std::string("ANONYMOUS")) -> ParameterList

        If ``dict`` is provided, it must be a dictionary whose keys are all
        strings and whose values are all of supported types.  The string name
        argument is optional and defaults to ``ANONYMOUS``.
        """
        this = _Teuchos.new_ParameterList(*args)
        try: self.this.append(this)
        except: self.this = this
    def set(self, *args):
        """
        set(self, string name, PyObject value) -> PyObject

        The templated C++ ``set()`` method is replaced in python with a method
        that takes a string name and a python object of supported type.  For
        example::

            plist = Teuchos.ParameterList()
            plist.set('b',True)
            plist.set('i',10)
            plist.set('f',2.718)
            plist.set('s','Trilinos')
            plist.set('d',{'a':1, 'b':2})
        """
        return _Teuchos.ParameterList_set(self, *args)

    def setParameters(self, *args):
        """
        setParameters(self, ParameterList source) -> ParameterList
        setParameters(self, PyObject dict) -> ParameterList

        The ``setParameters()`` method can take either a ``ParameterList`` or
        a python dictionary as its argument.  The ``ParameterList`` is updated
        to contain all of the entries of the argument.
        """
        return _Teuchos.ParameterList_setParameters(self, *args)

    def get(self, *args):
        """
        get(self, string name, PyObject default_value = None) -> PyObject

        The templated C++ ``get()`` method is replaced in python with a method
        that returns a python object.  For example::

            plist = Teuchos.ParameterList({'f':2.718, 'd':{'a':1. 'b':2}})
            print plist.get('f')
            print plist.get('d')

          will output::

            2.718
            {'a': 1, 'b': 2}
        """
        return _Teuchos.ParameterList_get(self, *args)

    def _print(self, *args):
        """
        _print(self, PyObject pf = None, int indent = 0, bool showTypes = False, 
            bool showFlags = True) -> PyObject

        Since ``print`` is a python keyword, the ``print()`` C++ method has
        been renamed ``_print`` in python.  It takes an optional file argument
        that defaults to standard output.  Its output is the same as the C++
        implementation.
        """
        return _Teuchos.ParameterList__print(self, *args)

    def unused(self, *args):
        """
        unused(self, pf=None)

        The ``unused()`` method in python takes an optional python file object
        as its argument, defaulting to standard output.  This specifies where
        the output should go.
        unused(self, pf=None)

        The ``unused()`` method in python takes an optional python file object
        as its argument, defaulting to standard output.  This specifies where
        the output should go.

        void
        Teuchos::ParameterList::unused(std::ostream &os) const

        Print out unused parameters in the ParameterList. 
        """
        return _Teuchos.ParameterList_unused(self, *args)

    def type(self, *args):
        """
        type(self, string name) -> PyObject

        Parameter type determination.  With the templated ``isType()`` methods
        disabled, type determination of python ``ParameterList`` entries is
        accomplished with the ``type()`` method, which returns python type
        objects.  For example::

          plist = Teuchos.ParameterList({'b':True, 's':'Trilinos'})
          print plist.type('b')
          print plist.type('s')

        results in::

          <type 'bool'>
          <type 'str'>

        A non-existent key given as the argument will raise a ``KeyError``
        exception.
        """
        return _Teuchos.ParameterList_type(self, *args)

    def __cmp__(self, *args):
        """
        __cmp__(self, PyObject obj) -> int
        __cmp__(self, ParameterList plist) -> int
        """
        return _Teuchos.ParameterList___cmp__(self, *args)

    def __contains__(self, *args):
        """
        __contains__(self, string name) -> int

        The python ``in`` operator works for ``ParameterList`` objects,
        searching the parameter names::

          plist = Teuchos.ParameterList({'b':False})
          print 'a' in plist
          print 'b' in plist

        produces::

          False
          True
        """
        return _Teuchos.ParameterList___contains__(self, *args)

    def __eq__(self, *args):
        """
        __eq__(self, PyObject obj) -> PyObject
        __eq__(self, ParameterList plist) -> PyObject

        The ``ParameterList`` equals operator (==)
        """
        return _Teuchos.ParameterList___eq__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, string name) -> PyObject

        Like dictionaries, parameters can be gotten using square brackets::

          plist = Teuchos.ParameterList()
          plist['f'] = 2.718
          e = plist['f']
        """
        return _Teuchos.ParameterList___getitem__(self, *args)

    def __iter__(self, *args):
        """
        __iter__(self) -> PyObject

        To iterate over the parameters in a ``ParameterList``, treat it like a
        dictionary::

          plist = Teuchos.ParameterList({'b':True,
                                         'i':10,
                                         'f':2.718,
                                         's':'Trilinos',
                                         'd':{'a':1, 'b':2}})
          for key in plist:
            print key, ':', plist[key]

        will result in the output::

          b : True
          d : {'a': 1, 'b': 2}
          f : 2.718
          i : 10
          s : Trilinos

        Note that the order of the parameters is somewhat indeterminant, as
        with dictionaries, because the iteration object is obtained from an
        equivalent dictionary, and dictionaries are ordered by hash
        function.
        """
        return _Teuchos.ParameterList___iter__(self, *args)

    def __len__(self, *args):
        """
        __len__(self) -> int

        The python ``len()`` function works on ``ParameterList`` objects just
        as on python dictionaries::

          plist = Teuchos.ParameterList({'b':True,
                                         'i':10,
                                         'f':2.718,
                                         's':'Trilinos',
                                         'd':{'a':1, 'b':2}})
          print len(plist)

        gives::

          5
        """
        return _Teuchos.ParameterList___len__(self, *args)

    def __ne__(self, *args):
        """
        __ne__(self, PyObject obj) -> PyObject
        __ne__(self, ParameterList plist) -> PyObject

        The ``ParameterList`` not equals operator (!=)
        """
        return _Teuchos.ParameterList___ne__(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, string name, PyObject value)

        Like dictionaries, parameters can be set using square brackets::

          plist = Teuchos.ParameterList()
          plist['zero'] = 0
        """
        return _Teuchos.ParameterList___setitem__(self, *args)

    def __repr__(self, *args):
        """
        __repr__(self) -> string

        The ``__repr__()`` method returns the ``__str__()`` output
        encapsulated by ``ParameterList(...)``.  The python ``eval`` function
        applied to the output of ``__repr__()`` will produce an equivalent
        ``ParameterList``.
        """
        return _Teuchos.ParameterList___repr__(self, *args)

    def __str__(self, *args):
        """
        __str__(self) -> string

        The ``__str__()`` method returns a string representation of the
        ``ParameterList`` as though it were a python dictionary.  The python
        ``eval`` function applied to the output of ``__str__()`` will produce
        an equivalent dictionary.
        """
        return _Teuchos.ParameterList___str__(self, *args)

    def has_key(self, *args):
        """
        has_key(self, string name) -> int

        Equivalent to the python dictionary has_key() method
        """
        return _Teuchos.ParameterList_has_key(self, *args)

    def items(self, *args):
        """
        items(self) -> PyObject

        Equivalent to the python dictionary items() method
        """
        return _Teuchos.ParameterList_items(self, *args)

    def iteritems(self, *args):
        """
        iteritems(self) -> PyObject

        Equivalent to the python dictionary iteritems() method
        """
        return _Teuchos.ParameterList_iteritems(self, *args)

    def iterkeys(self, *args):
        """
        iterkeys(self) -> PyObject

        Equivalent to the python dictionary iterkeys() method
        """
        return _Teuchos.ParameterList_iterkeys(self, *args)

    def itervalues(self, *args):
        """
        itervalues(self) -> PyObject

        Equivalent to the python dictionary itervalues() method
        """
        return _Teuchos.ParameterList_itervalues(self, *args)

    def keys(self, *args):
        """
        keys(self) -> PyObject

        Equivalent to the python dictionary keys() method
        """
        return _Teuchos.ParameterList_keys(self, *args)

    def update(self, *args):
        """
        update(self, PyObject dict, bool strict = True)
        update(self, ParameterList plist)
        """
        return _Teuchos.ParameterList_update(self, *args)

    def values(self, *args):
        """
        values(self) -> PyObject

        Equivalent to the python dictionary values() method
        """
        return _Teuchos.ParameterList_values(self, *args)

    def asDict(self, *args):
        """
        asDict(self) -> PyObject

        The ``asDict()`` method has been added to ``ParameterList``, which
        returns the contents of the ``ParameterList`` converted to a python
        dictionary.

        """
        return _Teuchos.ParameterList_asDict(self, *args)

ParameterList_swigregister = _Teuchos.ParameterList_swigregister
ParameterList_swigregister(ParameterList)


def haveSameValues(*args):
  """haveSameValues(ParameterList list1, ParameterList list2) -> bool"""
  return _Teuchos.haveSameValues(*args)
class ParameterListAcceptor(_object):
    """
    Base class objects that can accept a parameter list.

    ToDo: Finish Documentation!

    C++ includes: Teuchos_ParameterListAcceptor.hpp 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParameterListAcceptor, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, ParameterListAcceptor, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Teuchos.delete_ParameterListAcceptor
    __del__ = lambda self : None;
    def setParameterList(self, *args):
        """
        setParameterList(self, Teuchos::RCP<(Teuchos::ParameterList)> paramList)

        virtual void
        Teuchos::ParameterListAcceptor::setParameterList(RCP< ParameterList >
        const &paramList)=0

        Set parameters from a parameter list and return with default values.

        Parameters:
        -----------

        paramList:  [in] On input contains the parameters set by the client.
        Note that *paramList may have parameters set to their default values
        added while the list is being parsed either right away or later.

        Preconditions:  paramList.get() != NULL

        Postconditions:  this-> getParameterList(). get() == paramList.get()

        This is parameter list is "remembered" by *this object until it is
        unset using  unsetParameterList().

        Note: When this parameter list is passed in it is assumed that the
        client has finished setting all of the values that they want to set so
        that the list is completely ready to read (and be validated) by *this
        object. If the client is to change this parameter list by adding new
        options or changing the value of current options, the behavior of
        *this object is undefined. This is because, the object may read the
        options from *paramList right away or may wait to read some options
        until a later time. There should be no expectation that if an option
        is changed by the client that this will automatically be recognized by
        *this object. To change even one parameter, this function must be
        called again, with the entire sublist. 
        """
        return _Teuchos.ParameterListAcceptor_setParameterList(self, *args)

    def getNonconstParameterList(self, *args):
        """
        getNonconstParameterList(self) -> Teuchos::RCP<(Teuchos::ParameterList)>

        virtual
        RCP<ParameterList>
        Teuchos::ParameterListAcceptor::getNonconstParameterList()=0

        Get the parameter list that was set using  setParameterList(). 
        """
        return _Teuchos.ParameterListAcceptor_getNonconstParameterList(self, *args)

ParameterListAcceptor_swigregister = _Teuchos.ParameterListAcceptor_swigregister
ParameterListAcceptor_swigregister(ParameterListAcceptor)

def parameterList(*args):
  """
    parameterList() -> Teuchos::RCP<(Teuchos::ParameterList)>
    parameterList(string name) -> Teuchos::RCP<(Teuchos::ParameterList)>
    parameterList(ParameterList source) -> Teuchos::RCP<(Teuchos::ParameterList)>
    """
  return _Teuchos.parameterList(*args)

def __eq__(*args):
  """
    __eq__(ParameterEntry e1, ParameterEntry e2) -> bool
    __eq__(ParameterList list1, ParameterList list2) -> bool
    """
  return _Teuchos.__eq__(*args)

def __ne__(*args):
  """
    __ne__(ParameterEntry e1, ParameterEntry e2) -> bool
    __ne__(ParameterList list1, ParameterList list2) -> bool
    """
  return _Teuchos.__ne__(*args)

def sublist(*args):
  """
    sublist(Teuchos::RCP<(Teuchos::ParameterList)> paramList, string name, 
        bool mustAlreadyExist = False) -> Teuchos::RCP<(Teuchos::ParameterList)>
    sublist(Teuchos::RCP<(q(const).Teuchos::ParameterList)> paramList, 
        string name) -> Teuchos::RCP<(q(const).Teuchos::ParameterList)>
    """
  return _Teuchos.sublist(*args)

class EmptyXMLError(_object):
    """
    Thrown when attempting to parse an empty XML std::string.

    C++ includes: Teuchos_XMLObject.hpp 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, EmptyXMLError, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, EmptyXMLError, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, string what_arg) -> EmptyXMLError

        Teuchos::EmptyXMLError::EmptyXMLError(const std::string &what_arg) 
        """
        this = _Teuchos.new_EmptyXMLError(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_EmptyXMLError
    __del__ = lambda self : None;
EmptyXMLError_swigregister = _Teuchos.EmptyXMLError_swigregister
EmptyXMLError_swigregister(EmptyXMLError)

class XMLObject(_object):
    """Representation of an XML data tree."""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, XMLObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, XMLObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> XMLObject
        __init__(self, string tag) -> XMLObject

        The constructor that takes an ``XMLObjectImplem*`` argument has been
        removed.  The ``XMLObjectImplem`` class is hidden from the python
        user.
        """
        this = _Teuchos.new_XMLObject(*args)
        try: self.this.append(this)
        except: self.this = this
    def deepCopy(self, *args):
        """
        deepCopy(self) -> XMLObject

        XMLObject
        XMLObject::deepCopy() const

        Make a deep copy of this object. 
        """
        return _Teuchos.XMLObject_deepCopy(self, *args)

    def getTag(self, *args):
        """
        getTag(self) -> string

        const std::string
        & XMLObject::getTag() const

        Return the tag of the current node. 
        """
        return _Teuchos.XMLObject_getTag(self, *args)

    def hasAttribute(self, *args):
        """
        hasAttribute(self, string name) -> bool

        bool
        XMLObject::hasAttribute(const std::string &name) const

        Find out if the current node has an attribute of the specified name.

        """
        return _Teuchos.XMLObject_hasAttribute(self, *args)

    def getAttribute(self, *args):
        """
        getAttribute(self, string name) -> string

        const
        std::string & XMLObject::getAttribute(const std::string &name) const

        Return the value of the attribute with the specified name. 
        """
        return _Teuchos.XMLObject_getAttribute(self, *args)

    def getRequired(self, *args):
        """
        getRequired(self, string name) -> string

        const
        std::string & XMLObject::getRequired(const std::string &name) const

        Get an attribute, throwing an std::exception if it is not found. 
        """
        return _Teuchos.XMLObject_getRequired(self, *args)

    def getRequiredDouble(self, *args):
        """
        getRequiredDouble(self, string name) -> double

        double
        Teuchos::XMLObject::getRequiredDouble(const std::string &name) const

        Get a required attribute, returning it as a double. 
        """
        return _Teuchos.XMLObject_getRequiredDouble(self, *args)

    def getRequiredInt(self, *args):
        """
        getRequiredInt(self, string name) -> int

        int
        Teuchos::XMLObject::getRequiredInt(const std::string &name) const

        Get a required attribute, returning it as an int. 
        """
        return _Teuchos.XMLObject_getRequiredInt(self, *args)

    def getRequiredBool(self, *args):
        """
        getRequiredBool(self, string name) -> bool

        bool
        XMLObject::getRequiredBool(const std::string &name) const

        Get a required attribute, returning it as a bool. 
        """
        return _Teuchos.XMLObject_getRequiredBool(self, *args)

    def getWithDefault(self, *args):
        """
        getWithDefault(self, string name, string defaultValue) -> string

        std::string XMLObject::getWithDefault(const std::string &name, const
        std::string &defaultValue) const

        Get an attribute, assigning a default value if the requested attribute
        does not exist. 
        """
        return _Teuchos.XMLObject_getWithDefault(self, *args)

    def numChildren(self, *args):
        """
        numChildren(self) -> int

        int
        XMLObject::numChildren() const

        Return the number of child nodes owned by this node. 
        """
        return _Teuchos.XMLObject_numChildren(self, *args)

    def getChild(self, *args):
        """
        getChild(self, int i) -> XMLObject

        const XMLObject
        & XMLObject::getChild(int i) const

        Return the i-th child node. 
        """
        return _Teuchos.XMLObject_getChild(self, *args)

    def numContentLines(self, *args):
        """
        numContentLines(self) -> int

        int
        XMLObject::numContentLines() const

        Return the number of lines of character content stored in this node.

        """
        return _Teuchos.XMLObject_numContentLines(self, *args)

    def getContentLine(self, *args):
        """
        getContentLine(self, int i) -> string

        const
        std::string & XMLObject::getContentLine(int i) const

        Return the i-th line of character content stored in this node. 
        """
        return _Teuchos.XMLObject_getContentLine(self, *args)

    def toString(self, *args):
        """
        toString(self) -> string

        std::string
        XMLObject::toString() const

        Represent this node and its children as a std::string. 
        """
        return _Teuchos.XMLObject_toString(self, *args)

    def header(self, *args):
        """
        header(self) -> string

        std::string
        XMLObject::header() const

        Write the header for this object to a std::string. 
        """
        return _Teuchos.XMLObject_header(self, *args)

    def terminatedHeader(self, *args):
        """
        terminatedHeader(self) -> string

        std::string XMLObject::terminatedHeader() const

        Write the header for this object to a std::string. 
        """
        return _Teuchos.XMLObject_terminatedHeader(self, *args)

    def footer(self, *args):
        """
        footer(self) -> string

        std::string
        XMLObject::footer() const

        Write the footer for this object to a std::string. 
        """
        return _Teuchos.XMLObject_footer(self, *args)

    def isEmpty(self, *args):
        """
        isEmpty(self) -> bool

        bool
        Teuchos::XMLObject::isEmpty() const

        Find out if a node is empty. 
        """
        return _Teuchos.XMLObject_isEmpty(self, *args)

    def checkTag(self, *args):
        """
        checkTag(self, string expected)

        void
        XMLObject::checkTag(const std::string &expected) const

        Check that a tag is equal to an expected std::string. 
        """
        return _Teuchos.XMLObject_checkTag(self, *args)

    def addAttribute(self, *args):
        """
        addAttribute(self, string name, string value)

        void
        XMLObject::addAttribute(const std::string &name, const std::string
        &value)

        Add an attribute to the current node's atribute list. 
        """
        return _Teuchos.XMLObject_addAttribute(self, *args)

    def addDouble(self, *args):
        """
        addDouble(self, string name, double val)

        void
        Teuchos::XMLObject::addDouble(const std::string &name, double val)

        Add a double as an attribute. 
        """
        return _Teuchos.XMLObject_addDouble(self, *args)

    def addInt(self, *args):
        """
        addInt(self, string name, int val)

        void
        Teuchos::XMLObject::addInt(const std::string &name, int val)

        Add an int as an attribute. 
        """
        return _Teuchos.XMLObject_addInt(self, *args)

    def addBool(self, *args):
        """
        addBool(self, string name, bool val)

        void
        Teuchos::XMLObject::addBool(const std::string &name, bool val)

        Add a bool as an attribute. 
        """
        return _Teuchos.XMLObject_addBool(self, *args)

    def addChild(self, *args):
        """
        addChild(self, XMLObject child)

        void
        XMLObject::addChild(const XMLObject &child)

        Add a child node to the node. 
        """
        return _Teuchos.XMLObject_addChild(self, *args)

    def addContent(self, *args):
        """
        addContent(self, string contentLine)

        void
        XMLObject::addContent(const std::string &contentLine)

        Add a line of character content. 
        """
        return _Teuchos.XMLObject_addContent(self, *args)

    def __str__(self, *args):
        """
        __str__(self) -> string

        The ``__str__()`` method is provided so that it is possible to
        ``print`` an ``XMLObject`` object.  It returns the same string as the
        ``toString()`` method, but if ``toString()`` raises an exception (such
        as when the ``XMLObject`` is empty), the ``__str__()`` method returns
        the empty string.
        """
        return _Teuchos.XMLObject___str__(self, *args)

    __swig_destroy__ = _Teuchos.delete_XMLObject
    __del__ = lambda self : None;
XMLObject_swigregister = _Teuchos.XMLObject_swigregister
XMLObject_swigregister(XMLObject)

class XMLParameterListReader(_object):
    """
    Writes an XML object to a parameter list.

    C++ includes: Teuchos_XMLParameterListReader.hpp 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, XMLParameterListReader, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, XMLParameterListReader, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> XMLParameterListReader

        XMLParameterListReader::XMLParameterListReader()

        Construct a reader 
        """
        this = _Teuchos.new_XMLParameterListReader(*args)
        try: self.this.append(this)
        except: self.this = this
    def toParameterList(self, *args):
        """
        toParameterList(self, XMLObject xml) -> ParameterList

        ParameterList
        XMLParameterListReader::toParameterList(const XMLObject &xml) const

        Write the given XML object to a parameter list 
        """
        return _Teuchos.XMLParameterListReader_toParameterList(self, *args)

    __swig_destroy__ = _Teuchos.delete_XMLParameterListReader
    __del__ = lambda self : None;
XMLParameterListReader_swigregister = _Teuchos.XMLParameterListReader_swigregister
XMLParameterListReader_swigregister(XMLParameterListReader)

def __lshift__(*args):
  """
    __lshift__(std::ostream os, DescribableStreamManipulatorState d) -> std::ostream
    __lshift__(std::ostream os, ParameterEntry e) -> std::ostream
    __lshift__(std::ostream os, ParameterList l) -> std::ostream
    __lshift__(std::ostream os, XMLObject xml) -> std::ostream
    """
  return _Teuchos.__lshift__(*args)

def reductionTypeToString(*args):
  """
    reductionTypeToString(EReductionType reductType) -> char
    reductionTypeToString(XMLObject xml) -> string
    """
  return _Teuchos.reductionTypeToString(*args)

class XMLParameterListWriter(_object):
    """
    Writes a ParameterList to an XML object.

    C++ includes: Teuchos_XMLParameterListWriter.hpp 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, XMLParameterListWriter, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, XMLParameterListWriter, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> XMLParameterListWriter

        XMLParameterListWriter::XMLParameterListWriter()

        Construct a writer 
        """
        this = _Teuchos.new_XMLParameterListWriter(*args)
        try: self.this.append(this)
        except: self.this = this
    def toXML(self, *args):
        """
        toXML(self, ParameterList p) -> XMLObject

        XMLObject XMLParameterListWriter::toXML(const ParameterList &p) const

        Write the given list to an XML object 
        """
        return _Teuchos.XMLParameterListWriter_toXML(self, *args)

    __swig_destroy__ = _Teuchos.delete_XMLParameterListWriter
    __del__ = lambda self : None;
XMLParameterListWriter_swigregister = _Teuchos.XMLParameterListWriter_swigregister
XMLParameterListWriter_swigregister(XMLParameterListWriter)

class XMLInputSource(_object):
    """
    XMLInputSource represents a source of XML input that can be parsed to
    produce an XMLObject.

    The source might be a file, a socket, a std::string. The XMLObject is
    created with a call to the getObject() method.

    The source gets its data from a XMLInputStream object that is created
    (internally) to work with this source.

    getObject() is implemented with EXPAT if Teuchos is configured with
    --enable-expat.

    C++ includes: Teuchos_XMLInputSource.hpp 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, XMLInputSource, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, XMLInputSource, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Teuchos.delete_XMLInputSource
    __del__ = lambda self : None;
    def getObject(self, *args):
        """
        getObject(self) -> XMLObject

        XMLObject
        XMLInputSource::getObject() const

        Get an object by invoking the TreeBuildingXMLHandler on the input
        data. 
        """
        return _Teuchos.XMLInputSource_getObject(self, *args)

XMLInputSource_swigregister = _Teuchos.XMLInputSource_swigregister
XMLInputSource_swigregister(XMLInputSource)

class FileInputSource(XMLInputSource):
    """
    Instantiation of XMLInputSource class for reading XML from a file.

    C++ includes: Teuchos_FileInputSource.hpp 
    """
    __swig_setmethods__ = {}
    for _s in [XMLInputSource]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FileInputSource, name, value)
    __swig_getmethods__ = {}
    for _s in [XMLInputSource]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FileInputSource, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, string filename) -> FileInputSource

        FileInputSource::FileInputSource(const std::string &filename)

        Constructor. 
        """
        this = _Teuchos.new_FileInputSource(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_FileInputSource
    __del__ = lambda self : None;
FileInputSource_swigregister = _Teuchos.FileInputSource_swigregister
FileInputSource_swigregister(FileInputSource)

class StringInputSource(XMLInputSource):
    """
    Instantiation of XMLInputSource class for reading XML from a
    std::string.

    C++ includes: Teuchos_StringInputSource.hpp 
    """
    __swig_setmethods__ = {}
    for _s in [XMLInputSource]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, StringInputSource, name, value)
    __swig_getmethods__ = {}
    for _s in [XMLInputSource]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, StringInputSource, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, string text) -> StringInputSource

        StringInputSource::StringInputSource(const std::string &text)

        Constructor. 
        """
        this = _Teuchos.new_StringInputSource(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Teuchos.delete_StringInputSource
    __del__ = lambda self : None;
StringInputSource_swigregister = _Teuchos.StringInputSource_swigregister
StringInputSource_swigregister(StringInputSource)


def Teuchos_Version(*args):
  """Teuchos_Version() -> string"""
  return _Teuchos.Teuchos_Version(*args)
__version__ = Teuchos_Version().split()[2]

class Time(_object):
    """
    Basic wall-clock timer class.

    To time a section of code, place it in between calls to start() and
    stop().

    For std::exception safety and correct behavior in reentrant code, this
    class should generally be used only through the Teuchos::TimeMonitor
    mechanism.

    C++ includes: Teuchos_Time.hpp 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Time, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Time, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, string name, bool start = False) -> Time

        Teuchos::Time::Time(const
        std::string &name, bool start=false)

        Construct with a descriptive name. 
        """
        this = _Teuchos.new_Time(*args)
        try: self.this.append(this)
        except: self.this = this
    def wallTime(*args):
        """wallTime() -> double"""
        return _Teuchos.Time_wallTime(*args)

    if _newclass:wallTime = staticmethod(wallTime)
    __swig_getmethods__["wallTime"] = lambda x: wallTime
    def start(self, *args):
        """
        start(self, bool reset = False)

        void
        Teuchos::Time::start(bool reset=false)

        Starts the timer. 
        """
        return _Teuchos.Time_start(self, *args)

    def stop(self, *args):
        """
        stop(self) -> double

        double
        Teuchos::Time::stop()

        Stops the timer. 
        """
        return _Teuchos.Time_stop(self, *args)

    def totalElapsedTime(self, *args):
        """
        totalElapsedTime(self, bool readCurrentTime = False) -> double

        double
        Teuchos::Time::totalElapsedTime(bool readCurrentTime=false) const

        Returns the total time accumulated by this timer. This should be
        called only when the clock is stopped.. 
        """
        return _Teuchos.Time_totalElapsedTime(self, *args)

    def reset(self, *args):
        """
        reset(self)

        void
        Teuchos::Time::reset()

        Resets the cummulative time and number of times this timer has been
        called. Does not affect any other state. 
        """
        return _Teuchos.Time_reset(self, *args)

    def isRunning(self, *args):
        """
        isRunning(self) -> bool

        bool
        Teuchos::Time::isRunning() const

        Indicates if this timer is currently running, i.e., if it has been
        started but not yet stopped.

        It is necessary to know if a timer is running to avoid incorrectly
        starting or stopping in reentrant code. 
        """
        return _Teuchos.Time_isRunning(self, *args)

    def name(self, *args):
        """
        name(self) -> string

        const std::string&
        Teuchos::Time::name() const

        Return the name of this timer. 
        """
        return _Teuchos.Time_name(self, *args)

    def incrementNumCalls(self, *args):
        """
        incrementNumCalls(self)

        void
        Teuchos::Time::incrementNumCalls()

        Increment the number of times this timer has been called. 
        """
        return _Teuchos.Time_incrementNumCalls(self, *args)

    def numCalls(self, *args):
        """
        numCalls(self) -> int

        int
        Teuchos::Time::numCalls() const

        Return the number of times this timer has been called. 
        """
        return _Teuchos.Time_numCalls(self, *args)

    __swig_destroy__ = _Teuchos.delete_Time
    __del__ = lambda self : None;
Time_swigregister = _Teuchos.Time_swigregister
Time_swigregister(Time)

def Time_wallTime(*args):
  """Time_wallTime() -> double"""
  return _Teuchos.Time_wallTime(*args)



